
{$R-}
{$Z+}
{$S IconOf }
unit DummyUnit;

interface
uses
          Types,
         Memory,
      QuickDraw,
       OSEvents,
        Dialogs,
          Files,
       Packages,
      Resources,
     PasLibIntf,
      ToolUtils,
         Errors,
      HyperXCmd;





implementATION





procedure HyperRun(paramPtr: XCmdPtr); forward;

procedure ENTRYPOINT(paramPtr: XCmdPtr);
   
   begin { ENTRYPOINT}
      HyperRun(paramPtr);
   end {ENTRYPOINT};





procedure HyperRun(paramPtr: XCmdPtr);
   
   const
         IconSize = 128;
   
   type
         IconType = packed array [ 1..IconSize ] of char;
          IconPtr = ^IconType;
       IconHandle = ^IconPtr;
   
   var
               Doc,
            ErrStr: Str255;
               ICN,
               UID: integer;
                 H: Handle;
          IconName: Str255;
          CurIconH,
             IconH: IconHandle;
   
   
   
   
   
   procedure ScanIcon;
      
      const
                  cr = 13;
      
      var
                   lp,
                   ip: integer;
                    p: longint;
                 Line: Str255;
              TheByte: char;
      
      
      
      
      
      procedure CheckRes(Msg: Str255);
         
         var
                     Err: OsErr;
         
         begin { CheckRes}
            Err := ResError;
            if Err <> NoErr then
               debugstr('oops');
         end {CheckRes};
      
      
      
      
      
      procedure ScanHeader;
         
         
         
         
         
         procedure FetchString(H: Handle; var S: Str255; var Index: longint);
            
            type
                     CharA = packed array [ 1..20000 ] of char;
                     CharP = ^CharA;
                     CharH = ^CharP;
            
            var
                          i,
                     StrLen: integer;
                       Size,
                          p: longint;
                         Ch: char;
            
            begin { FetchString}
               Size := GetHandleSize(H);
               if CharH(H) ^^ [ Size - 1 ] = Chr(0) then
                  Size := Size - 1;
               p := Index;
               S := '';
               if p < Size
               then
                  begin
                     while (p < Size) and (CharH(H) ^^ [ p ] <> chr(cr)) do
                        p := p + 1;
                     StrLen := p - Index;
                     if StrLen > 255 then
                        StrLen := 255;
                     BlockMove(Ptr(Ord4(H ^) +Index - 1), Ptr(Succ(Ord4(@ S))),
                        StrLen);
                     S[ 0 ] := Chr(StrLen);
                     Index := p + 1;
                  end
               else
                  begin
                     S := '';
                     Index := 0;
                  end;
            end {FetchString};
         
         
         
         
         
         procedure GetB;
            
            var
                         V1,
                         V2: integer;
            
            
            
            
            
            procedure GetC(var V: integer);
               
               var
                             c: char;
               
               begin { GetC}
                  lp := lp + 1;
                  c := Line[ lp ];
                  if c in [ '0'..'9', 'A'..'F' ] then
                     begin
                        if c in [ '0'..'9' ]
                        then
                           V := Ord(c) -Ord('0')
                        else
                           V := Ord(c) -Ord('A') +10;
                     end;
               end {GetC};
            
            
            
            
            
            
            begin { GetB}
               GetC(V1);
               GetC(V2);
               TheByte := Chr(BitShift(V1, 4) +V2);
            end {GetB};
         
         
         
         
         
         
         begin { ScanHeader}
            ip := 0;
            IconH := IconHandle(NewHandle(IconSize));
            p := 0;
            repeat
               FetchString(H, Line, p);
               if p > 0 then
                  begin
                     if pos('X-POP-Face:', Line) = 1 then
                        begin
                           lp := 12;
                           while lp < Length(Line) do
                              begin
                                 GetB;
                                 if ip < IconSize then
                                    begin
                                       ip := ip + 1;
                                       IconH ^^ [ ip ] := TheByte;
                                    end;
                              end;
                        end;
                  end;
            until p = 0;
         end {ScanHeader};
      
      
      
      
      
      procedure CreateIcon;
         
         begin { CreateIcon}
            UID := UniqueID('ICON');
            SetHandleSize(Handle(IconH), IconSize);
            AddResource(Handle(IconH), 'ICON', UID, IconName);
            CheckRes('AddResource');
            WriteResource(Handle(IconH));
            CheckRes('WriteResource');
         end {CreateIcon};
      
      
      
      
      
      procedure ReturnOld;
         
         var
                      Ty: ResType;
                      Na: Str255;
         
         begin { ReturnOld}
            GetResInfo(Handle(CurIconH), UID, Ty, Na);
         end {ReturnOld};
      
      
      
      
      
      procedure HaveBoth;
         
         var
                    Diff: boolean;
                       i: integer;
         
         begin { HaveBoth}
            Diff := false;
            for i := 1 to IconSize do
               Diff := Diff or (CurIconH ^^ [ i ] <> IconH ^^ [ i ]);
            if Diff
            then
               begin { icons different, update old icon }
                  CurIconH ^^ := IconH ^^;
                  ChangedResource(Handle(CurIconH));
                  WriteResource(Handle(CurIconH));
               end
            else
               begin { icons the same, return old icon }
               end;
            ReturnOld;
         end {HaveBoth};
      
      
      
      
      
      procedure NoNewIcon;
         
         begin { NoNewIcon}
            if CurIconH <> NIL
            then
               ReturnOld
            else
               UID := 0;
         end {NoNewIcon};
      
      
      
      
      
      
      begin { If icon in header then
           if old icon then
		      compare icons;
			  if different, update old to new, return old
			  else if same, do nothing, return old;
		   else
		     create new icon;
		else
		  if old icon, return old icon
		  else
		  return no icon;
		  }
         CurIconH := IconHandle(GetNamedResource('ICON', IconName));
         ScanHeader;
         if ip > 0
         then
            begin
               if CurIconH <> NIL
               then
                  HaveBoth
               else
                  CreateIcon;
            end
         else
            NoNewIcon;
      end {ScanIcon};
   
   
   
   
   
   
   begin { HyperRun}
      H := paramPtr ^.params[ 1 ];
      ZeroToPas(paramptr, paramPtr ^.params[ 2 ] ^, IconName);
      ScanIcon;
      ErrStr := '';
      NumToString(UID, ErrStr);
      paramPtr ^.returnValue := PasToZero(paramPtr, ErrStr);
   end {HyperRun};





end.
