
(*
	Pascal Launch.p -mbg off
*)
{$R-}
{$Z+}
{$S Launch }
unit DummyUnit;

interface
uses
          Types,
         Memory,
      QuickDraw,
       OSEvents,
        Dialogs,
          Files,
       Packages,
      Resources,
     PasLibIntf,
      ToolUtils,
      HyperXCmd;





implementATION





procedure HyperRun(paramPtr: XCmdPtr); forward;

procedure ENTRYPOINT(paramPtr: XCmdPtr);
   
   begin { ENTRYPOINT}
      HyperRun(paramPtr);
   end {ENTRYPOINT};





procedure HyperRun(paramPtr: XCmdPtr);
   
   var
               Doc,
            ErrStr: Str255;
           Running: boolean;
   
   
   
   
   
   procedure Run(Doc: Str255; var ReturnErrorCode: Str255);
      
      const
              DeskFn = 'Desktop';
      
      var
                  Err: integer;
                 FCre,
                 FTyp: OsType;
      
      
      
      
      
      procedure Assert(E: integer; Msg: Str255);
         
         var
                      ES: Str255;
         
         begin { Signal}
            if E <> NoErr then
               begin
                  NumToString(E, ES);
                  ReturnErrorCode := concat('Error #', ES, ' in ', Msg);
                  Exit(Run);
               end;
         end {Assert};
      
      
      
      
      
      procedure DoSubLaunch(App: Str255; var Err: integer);
         
         type
          pLaunchStruct = ^LaunchStruct;
           LaunchStruct = record
                                  pfName: StringPtr;
                                   param: INTEGER;
                                      LC: packed array [ 1..2 ] of CHAR; {extended parameters:}
                             extBlockLen: LONGINT; {number of bytes in extension = 6}
                                  fFlags: INTEGER; {Finder file info flags (see below)}
                             launchFlags: LONGINT; {bit 31,30=1 for sublaunch, others reserved}
                         end; {LaunchStruct}
         
         var
                myLaunch: LaunchStruct; {launch structure}
                    myPB: CInfoPBRec;
                      PB: WDPBRec;
         
         
         
         
         
         function LaunchIt(pLaunch: pLaunchStruct): OSErr; {< 0 means error}
            inline $205F, $A9F2, $3E80;
         
         
         begin { DoSubLaunch}
            with myPB do
               begin
                  ioNamePtr := @ App;
                  ioVRefNum := 0;
                  ioFDirIndex := 0;
                  ioDirID := 0;
               end;
            Assert(PBGetCatInfo(@ MyPB, FALSE), 'getcatinfo');
            with myLaunch do
               begin
                  pfName := @ App;
                  param := 0;
                  LC := 'LC';
                  extBlockLen := 6;
{copy flags; set bit 6 of low byte to 1 for RO access:}
                  fFlags := myPB.ioFlFndrInfo.fdFlags;
                  LaunchFlags := $C0000000;
               end;
            Err := LaunchIt(@ myLaunch);
            if Err = -49 then
               begin
                  myLaunch.fFlags := BOr(myLaunch.fFlags, $0040);
                  Err := LaunchIt(@ myLaunch);
               end;
            if Err > NoErr then
               Err := NoErr;
         end {DoSubLaunch};
      
      
      
      
      
      procedure PointToDir(Doc: Str255; var WD: integer);
         
         var
                       q: integer;
                    Doc2: Str255;
                      PB: WDPBRec;
                       P: ParamBlockRec;
         
         begin { PointToDir}
            q := length(Doc);
            repeat
               q := q - 1;
            until (q <= 1) or (Doc[ q ] = ':');
            Doc2 := Copy(Doc, 1, q - 1);
            if pos(':', Doc2) > 0
            then
               begin
                  with PB do
                     begin
                        ioNamePtr := StringPtr(@ Doc2);
                        ioVRefNum := 0;
                        ioWDProcID := 0;
                        ioWDDirID := 0;
                     end;
                  Err := PBOpenWD(WDPBPtr(@ PB), false);
                  Assert(Err, 'openWD');
                  WD := PB.iovrefnum;
               end
            else
               begin
                  with P do
                     begin
                        ioCompletion := NIL;
                        ioNamePtr := StringPtr(@ Doc2);
                        ioVolIndex := -1;
                        ioVRefNum := 0;
                     end;
                  Err := PBGetVInfo(ParmBlkPtr(@ P), false);
                  Assert(Err, 'GetVInfo');
                  WD := P.iovrefnum;
               end;
         end {PointToDir};
      
      
      
      
      
      procedure TrimFn(Doc: Str255; var FName: Str255);
         
         var
                       q: integer;
         
         begin { TrimFn}
            FName := Doc;
            repeat
               q := pos(':', FName);
               if q > 0 then
                  Delete(FName, 1, q);
            until q = 0;
         end {TrimFn};
      
      
      
      
      
      procedure RunX(DeskVol: integer);
         
         var
                 AppName: Str255;
                  AppDir: longint;
                     Ref: integer;
                       H: Handle;
                     Len: longint;
                    Done: boolean;
         
         
         
         
         
         procedure Scan;
            
            type
                       Rec = record
                                       Icon: OsType;
                                        Dir: longint;
                                       Appl: Str255;
                            end;
               
                      RPtr = ^Rec;
            
            var
                          P: RPtr;
                         LA: integer;
            
            begin { Scan}
               P := RPtr(H ^);
               Done := false;
               repeat
                  with P ^ do
                     begin
{writeln('ICON="', Icon, '"   Dir = ', Dir: 9, '  Appl = "',
                        Appl, '"');}
                        if Icon = FCre
                        then
                           Done := true
                        else
                           begin
                              LA := Length(Appl) +1 + 8;
                              if Odd(LA) then
                                 LA := LA + 1;
                              P := RPtr(Ord4(P) +LA);
                              Len := Len - LA;
                           end;
                     end;
               until Done or (Len < 0);
               AppName := P ^.Appl;
               AppDir := P ^.Dir;
            end {Scan};
         
         
         
         
         
         procedure DoIt;
            
            type
                     Str40 = string[ 40 ];
            
            var
                      fName: Str255;
                         PB: WDPBRec;
                      docwd: integer;
                     xxDoc2: Str255;
                          q: integer;
            
            
            
            
            
            procedure debugstr(S: Str255); inline $ABFF;
            
            procedure BuildDocList;
               
               type
                        Str40 = string[ 40 ];
                        AHRec = record
                                           msg: integer;
                                         Count: integer;
                                           Vol: integer;
                                         FType: OsType;
                                          Vers: integer;
                                         FName: Str40;
                               end;
                  
                         APtr = ^AHRec;
                         AHan = ^APtr;
                          HPT = ^AHan;
               
               var
                          Temp: Str255;
                            PB: WDPBRec;
                         docwd: integer;
                             q: integer;
                            AH: AHan;
                            HP: HPT;
                           msg,
                           cnt: integer;
                           FIA: AppFile;
               
               
               
               
               
               procedure debugstr(S: Str255); inline $ABFF;
               
               
               begin { BuildDocList}
                  PointToDir(Doc, docwd);
                  AH := AHan(NewHandle(SizeOf(AHRec)));
                  if AH <> NIL then
                     begin
                        with AH ^^ do
                           begin
                              Msg := appOpen;
                              Count := 1;
                              Vol := Docwd;
                              Ftype := FTyp;
                              Vers := 0;
                              TrimFn(Doc, Temp);
                              FName := Temp;
                           end;
                        HP := HPT($AEC);
                        HP ^ := AH;
                     end;
               end {BuildDocList};
            
            
            
            
            
            procedure GoToVol(Vol, Dir: longint);
               
               var
                            PB: WDPBRec;
               
               begin { GoToVol}
                  with PB do
                     begin
                        ioNamePtr := NIL;
                        ioVRefNum := Vol;
                        ioWDProcID := 0;
                        ioWDDirID := Dir;
                     end;
                  Err := PBOpenWD(WDPBPtr(@ PB), false);
                  Assert(Err, 'OpenWD');
                  Err := SetVol(NIL, PB.iovrefnum);
               end {GoToVol};
            
            
            
            
            
            procedure RunTheProg;
               
               type
                pLaunchStruct = ^LaunchStruct;
                 LaunchStruct = record
                                        pfName: StringPtr;
                                         param: INTEGER;
                               end; {LaunchStruct}
                  
                        Str40 = string[ 40 ];
               
               var
                     pMyLaunch: pLaunchStruct;
                      myLaunch: LaunchStruct;
               
               
               
               
               
               procedure LaunchIt(pLnch: pLaunchStruct); inline $205F, $A9F2;
               
               
               begin { RunTheProg}
                  pMyLaunch := @ myLaunch;
                  with pMyLaunch ^ do
                     begin
                        pfName := @ AppName;
                        param := 0;
                     end;
                  LaunchIt(pMyLaunch);
               end {RunTheProg};
            
            
            
            
            
            
            begin { DoIt}
               BuildDocList;
               Assert(Err, 'build doc list');
               GoToVol(DeskVol, AppDir);
               Assert(Err, 'gotovol');
               DoSubLaunch(AppName, Err);
               Assert(Err, 'Launching');
               Running := true;
            end {DoIt};
         
         
         
         
         
         
         begin { RunX}
            SetResLoad(false);
            Ref := OpenRFPerm(DeskFn, DeskVol, fsRdPerm);
            SetResLoad(true);
            if Ref = -1
            then
               begin
                  Err := ResError;
                  Assert(Err, 'OpenRF');
               end
            else
               begin
                  H := Get1Resource('APPL', 0);
                  if H = NIL
                  then
                     Assert(-99, 'GetResource error')
                  else
                     begin
                        HLock(H);
                        Len := GetHandleSize(H);
                        Scan;
                        HUnLock(H);
                        DisposHandle(H);
                        if Done then
                           Doit;
                     end;
                  CloseResFile(Ref);
               end;
         end {RunX};
      
      
      
      
      
      procedure GFI;
         
         var
                      FI: FInfo;
         
         begin { GFI}
            Err := GetFInfo(Doc, 0, FI);
            if Err = NoErr then
               with FI do
                  begin
                     FCre := fdCreator;
                     FTyp := FdType;
                  end;
         end {GFI};
      
      
      
      
      
      procedure ScanVols;
         
         var
                     Drv: integer;
                      PB: ParamBlockRec;
                 VolName: Str255;
         
         begin { ScanVols}
            Drv := 1;
            Running := false;
            repeat
               with PB do
                  begin
                     ioNamePtr := StringPtr(@ VolName);
                     ioVRefNum := 0;
                     ioVolIndex := Drv;
                  end;
               Err := PBGetVInfo(ParmBlkPtr(@ PB), false);
               if Err <> -35 then
                  begin
                     Assert(Err, 'GetVInfo error');
                     RunX(PB.ioVRefNum);
                     Drv := Drv + 1;
                  end;
            until Running or (Err <> NoErr);
         end {ScanVols};
      
      
      
      
      
      procedure DirectRun;
         
         var
                    ADir: integer;
                    FDoc: Str255;
         
         
         
         
         
         procedure BuildNullDocList;
            
            type
                     Str40 = string[ 40 ];
                     AHRec = record
                                        msg: integer;
                                      Count: integer;
                                        Vol: integer;
                                      FType: OsType;
                                       Vers: integer;
                                      FName: Str40;
                            end;
               
                      APtr = ^AHRec;
                      AHan = ^APtr;
                       HPT = ^AHan;
            
            var
                         AH: AHan;
                         HP: HPT;
            
            begin { BuildNullDocList}
               AH := AHan(NewHandleSysClear(SizeOf(AHRec)));
               if AH <> NIL then
                  begin
                     with AH ^^ do
                        begin
                           Msg := appOpen;
                           Count := 0;
                           Vers := 0;
                        end;
                     HP := HPT($AEC);
                     HP ^ := AH;
                  end;
            end {BuildNullDocList};
         
         
         
         
         
         
         begin { DirectRun}
            BuildNullDocList;
            PointToDir(Doc, ADir);
            Err := SetVol(NIL, ADir);
            Assert(Err, 'SetVol');
            TrimFn(Doc, FDoc);
            DoSubLaunch(FDoc, Err);
            Assert(Err, 'Launch');
         end {DirectRun};
      
      
      
      
      
      
      begin { Run}
         ReturnErrorCode := '';
         GFI;
         Assert(Err, 'GetFileInfo');
         if FTyp = 'APPL'
         then
            DirectRun
         else
            ScanVols;
         if not Running then
            ErrStr := 'Can''t find the application.';
      end {Run};
   
   
   
   
   
   
   begin { HyperRun}
      ZeroToPas(paramPtr, paramPtr ^.params[ 1 ] ^, Doc);
      ErrStr := '??Error??';
      Run(Doc, ErrStr);
      paramPtr ^.returnValue := PasToZero(paramPtr, ErrStr);
   end {HyperRun};





end.
