 
program Nag;
(*Hacked together to try out the Notification mgr.
					University of Minnesota 
		Microcomputer and Workstation Systems Research Group.
				University of Minnesota, 1988.
				
  Revised to talk to extended pop daemon using MacTCP.  Spring '89


 What we're doing:
 	Load up username, servername and two integers (spool bytes and
	number of inbox files) from settings file.
 	If settings file does not exist, get username and servername 
	from the user.
	Sit in the main event loop and...
		Do nothing until at least DeltaT ticks have elapsed since last look.
		Talk to popd and compare current answer to the last time.
		if current <> last (and both are nonzero), scream at the user.
		Current peek becomes last peek.
	When it's time to go home, update the settings file.
	
 TTD:
	7. Someday implement Preferences menu.  Meantime its ResEdit...

*)
{$D+}

uses
       MemTypes,
      QuickDraw,
         OSIntf,
       ToolIntf,
       PackIntf,
   Notification,
         FileIo,
     MacTCPIntf;

const
    SleepTicks = 30 { .5 seconds per wakeup };
	ShortPause = 6 { .1 second for fast lookup };
{}
       AppleID = 128; {menu resource IDs}
        FileID = 129;
        EditID = 130;
     OptionsID = 131;
{}
        AppleM = 1; {index for apple menu in myMenus (array of menu handles)}
         FileM = 2; {etc}
         EditM = 3;
      OptionsM = 4;
     MenuCount = 4; {total number of menus}
{}
   AboutMeItem = 1; {menu item in apple menu for About Nag item}
{}
      QuitItem = 1;
{}
      UndoItem = 1;
       CutItem = 3;
      CopyItem = 4;
     PasteItem = 5;
     ClearItem = 6;
{}
     SetUpItem = 1; {For user to point me at a server}
ShowStatusItem = 2; {I'll show you what I'm talking to}
{}
   AboutMeDLOG = 128; {rsrc ids for dlgs}
GenericAlertID = 129; {one size fits all}
    ShowStatID = 130;
     SetStatID = 131;
     StrListID = 128; {misc strings...}
{}
 CantDoThatStr = 1;
  GetNewSysStr = 2;
   NoMemoryStr = 3;
        NagStr = 4;
 DiskLockedStr = 5;
  DiskWeirdStr = 6;
   DiskFullStr = 7;
  DiskWrErrStr = 8;
 ButImBlindStr = 9;
NagSettingsStr = 10;
   SleepIntStr = 11;
 TCPInitErrStr = 12;
 TCPConnErrStr = 13;
 TCPReadErrStr = 14;
TCPWriteErrStr = 15;
ServiceNameStr = 16;
ServicePortStr = 17;
       InqMStr = 18;
    QuitPOPStr = 19;
     NoMailStr = 20;
 NothingYetStr = 21;
{}
        DeltaT = 18000; {5 mins currently...}
NameLookupTimeoutSeconds = 30;
ConnectTimeOutSeconds = 20;
IOTimeOutSeconds = 3;
      MaxLoops = 6;
      LoopTime = 120;
{}
        inqpop = 'inqm';
       quitpop = 'quit';
         fnStr = 'Nag Settings';
    OKPassword = 'Nag Info';

type
      NMRecPtr = ^NMRec;
          CRec = record
                     serverName: Str255; {full name of mail server}
                       userName: Str255; {who to finger}
                        Blatant: integer;
                end;

var
        myMenus: array [ 1..MenuCount ] of MenuHandle; {array of handles to the menus}
       doneFlag: BOOLEAN; {TRUE if user has chosen Quit command}
SysFolderRefNum: INTEGER; {vRefNum of System Folder}
            msg: Str255; {the ugly nagging message}
      sleepTime: LONGINT; {time between peeks; initialized to DeltaT}
  thePopService: Str255; {just to be general}
     thePopPort: LONGINT; {normally 109}
NotifyQueueElement: NMRec; {Notification Manager Queue record ptr}
       lastTime: LONGINT; {when we last peeked}
        iCanSee: BOOLEAN; {i know a server and username}
     IconHandle: Handle;
      SndHandle: Handle;
       NextTime: longint;
          Loops: integer;
         Config: CRec;
{$S Main}





procedure dsi(s: Str255; v: longint);
   
   var
                 t: str255;
   
   begin { dsi}
      numtostring(V, T);
      debugstr(concat(S, T));
   end {dsi};





procedure SetMsg(MsgIndex: integer);
   
   begin { SetMsg}
      GetIndString(msg, StrListID, MsgIndex);
      msg := Concat(msg, Config.userName, '.');
   end {SetMsg};





procedure IdleProc;
   
   var
               Got: boolean;
                Ev: EventRecord;
   
   begin { IdleProc}
      Got := EventAvail(everyevent, Ev);
   end {IdleProc};





procedure Terminate;
   
   begin {Terminate}
      ExitToShell;
   end {Terminate};





procedure DoAlert(strIndex: INTEGER; appendStr: Str255);
   
   var
            ignore: INTEGER;
             sorry: Str255;
   
   begin { DoAlert}
      GetIndString(sorry, StrListID, strIndex);
      ParamText(sorry, appendStr, '', '');
      ignore := NoteAlert(GenericAlertID, NIL);
   end {DoAlert};





procedure CkDiskError(oe: OSErr);
   
   begin {CkDiskError}
      if oe = NoErr
      then
         
      else
         begin
            if oe = wPrErr
            then
               DoAlert(DiskLockedStr, '')
            else
               if oe = dskFulErr
               then
                  DoAlert(DiskFullStr, '')
               else
                  DoAlert(DiskWrErrStr, '');
            Terminate;
         end;
   end {CkDiskError};





procedure FailOSErr(oe: OSErr);
   
   begin {FailOSErr}
      if oe = NoErr
      then
         
      else
         begin
            if oe = memFullErr
            then
               DoAlert(NoMemoryStr, '')
            else
               DoAlert(DiskWeirdStr, '');
            Terminate;
         end;
   end {FailOSErr};





procedure CreateSettingsFile;
   
   begin { CreateSettingsFile}
      MakeFile(SysFolderRefNum, fNStr, 'NAAG', 'GAAN');
   end {CreateSettingsFile};





procedure ShowAboutMeDialog;
   
   var
           itemHit: INTEGER;
         theDialog: DialogPtr;
   
   begin { ShowAboutMeDialog}
      theDialog := GetNewDialog(AboutMeDLOG, NIL, WindowPtr(-1));
      repeat
         ModalDialog(NIL, itemHit)
      until itemHit = OK;
      DisposDialog(theDialog);
   end {ShowAboutMeDialog};





function DHook(item: INTEGER; dlgP: DialogPtr): INTEGER;
   
   begin { DHook}
      if item = 9
      then
         DHook := 1
      else
         DHook := item;
   end {DHook};





procedure DrawOKDefault(theDialog: DialogPtr; theItem: INTEGER);
   
   const
         curveRad = 16;
   
   var
           savePen: PenState;
          tempType: Integer;
        tempHandle: Handle;
          tempRect: Rect;
   
   begin { DrawOKDefault}
      GetPenState(savePen);
      GetDItem(theDialog, 1, tempType, tempHandle, tempRect);
      PenSize(3, 3);
      FrameRoundRect(tempRect, curveRad, curveRad);
      SetPenState(savePen);
   end {DrawOKDefault};





procedure GetSettings(var SettingsLoaded: boolean);
   
   var
                oe: OSErr;
            Secret,
               Bla: Str255;
                 B: longint;
   
   begin {SettingsLoaded}
      OpenIn(sysFolderRefNum, fnStr);
      if FileError = NoErr
      then
         with Config do
            begin
               GetLine(Secret);
               GetLine(UserName);
               GetLine(serverName);
               GetLine(Bla);
               StringToNum(Bla, B);
               Blatant := B;
               CloseIn;
               SettingsLoaded := TRUE;
               if Secret = OKPassword
               then
{OK}
                  
               else
                  SettingsLoaded := FALSE
            end
      else
         SettingsLoaded := FALSE;
   end {SettingsLoaded};
{$S Initialize}





procedure Initialize;
   
   var
              Sys6: BOOLEAN; {running sys 6.0+}
              sStr: Str255; {sleep interval string in seconds}
               Err: integer;
    SettingsLoaded: boolean;
   
   
   
   
   
   procedure SetUpMenus;
      
      var
                    i: INTEGER;
      
      begin { SetUpMenus}
         myMenus[ AppleM ] := GetMenu(AppleID); {read Apple menu from resource file}
         AddResMenu(myMenus[ AppleM ], 'DRVR'); {add desk accessory names to Apple menu}
         myMenus[ FileM ] := GetMenu(FileID); {read file menu from resource file}
         myMenus[ EditM ] := GetMenu(EditID); {read Edit menu from resource file}
         myMenus[ OptionsM ] := GetMenu(OptionsID); {etc}
         for i := 1 TO menuCount do
            InsertMenu(myMenus[ i ], 0);
         DrawMenuBar;
      end {SetUpMenus};
   
   
   
   
   
   procedure WhereAmI(var SysFolderRef: INTEGER; var Sys6Plus: BOOLEAN);
      
      const
               SixOh = $0600;
      
      var
             theWorld: SysEnvRec;
      
      begin { WhereAmI}
         if SysEnvirons(1, theWorld) = NoErr then
            with theWorld do
               begin
                  Sys6Plus := systemVersion >= SixOh;
                  SysFolderRef := sysVRefNum;
               end;
      end {WhereAmI};
   
   
   
   
   
   procedure GetI(Index: integer; var V: longint);
      
      var
                    T: Str255;
      
      begin { GetI}
         GetIndString(T, StrListID, Index);
         StringToNum(T, V); {this is in ticks.}
      end {GetI};
   
   
   
   
   
   procedure _DataInit; external;
   
   procedure ToolInit;
      
      begin { ToolInit}
         UnloadSeg(@ _DataInit);
         InitGraf(@ thePort);
         InitFonts;
         FlushEvents(everyEvent, 0);
         InitWindows;
         InitMenus;
         TEInit;
         InitDialogs(NIL);
         InitCursor;
         SetUpMenus;
         MaxApplZone;
      end {ToolInit};
   
   
   
   
   
   procedure VarInit;
      
      begin { VarInit}
         NotifyQueueElement.nmRefCon := 0;
         sleepTime := DeltaT;
         ConFig.serverName := '';
         Config.Blatant := 0;
         Config.userName := '';
         iCanSee := FALSE;
         lastTime := 0;
         NextTime := 0;
         Loops := 0;
         SndHandle := NIL;
      end {VarInit};
   
   
   
   
   
   procedure InitRest;
      
      begin { InitRest}
         IconHandle := GetResource('SICN', 1000);
         GetI(SleepIntStr, sleepTime);
         GetI(ServicePortStr, thePopPort);
         GetIndString(thePopService, StrListID, ServiceNameStr);
         GetSettings(SettingsLoaded);
         if not SettingsLoaded
         then
            begin
               CreateSettingsFile;
               SetMsg(ButImBlindStr);
               ShowAboutMeDialog;
            end
         else
            begin
               SetMsg(NothingYetStr);
               iCanSee := TRUE;
            end; {-- no workee!!
	  SndHandle := GetNamedResource( 'snd ', 'Mail' );
	  --}
         if SndHandle = NIL then
            SndHandle := Handle(-1);
         Err := TCPIdle(Ptr( @ IdleProc));
      end {InitRest};
   
   
   
   
   
   
   begin {Initialize}
      ToolInit;
      VarInit;
      WhereAmI(SysFolderRefNum, Sys6); {ck for sys 6}
      if not Sys6
      then
         begin {not running system 6.0 or better}
            DoAlert(GetNewSysStr, '');
            Terminate;
         end
      else
         InitRest;
   end {Initialize};
{$S Main }





procedure Resp(nmReqPtr: QElemPtr);
   
   begin {Resp}
      with NMRecPtr(nmReqPtr) ^ do
         begin
            nmRefCon := 0; {notification is done}
            if NMRemove(nmReqPtr) = NoErr then
               ;
         end;
   end {Resp};





procedure SetNotify;
   
   var
                oe: OSErr;
   
   begin {SetNotify}
      if NotifyQueueElement.nmRefCon = 0 then
         begin
            with NotifyQueueElement do
               begin
                  qType := 8;
                  nmMark := 0;
                  if Config.Blatant = 1
                  then
                     nmSIcon := NIL
                  else
                     nmSIcon := IconHandle;
                  if Loops = MaxLoops
                  then
                     nmSound := SndHandle
                  else
                     nmSound := NIL;
                  if (Config.Blatant = 1) or (IconHandle = NIL)
                  then
                     nmStr := StringPtr(@ Msg)
                  else
                     nmStr := NIL;
                  nmRefCon := 1; {notification is pending}
                  nmResp := ProcPtr(@ Resp);
               end;
            FailOSErr(NMInstall(QElemPtr(@ NotifyQueueElement)));
         end;
   end {SetNotify};


procedure HandleEvents( Pause: integer );   forward;




procedure CheckForMail;
   
   var
YouHaveSomeNewMail,
    SettingsLoaded: boolean;
   
   
   
   
   
   procedure CheckMail(var HaveMail: BOOLEAN);
      
      var
                    s: Str255;
      
      
      
      
      
      procedure FailTCP(oe: OSErr; errStrNo: INTEGER);
         
         var
                     Err: OsErr;
         
         begin {FailTCP}
            if oe < 0 then
               begin
                  Err := TCPClose;
                  HaveMail := FALSE;
                  SetMsg(errStrNo);
                  Exit(CheckMail);
               end;
            HandleEvents( ShortPause );
         end {FailTCP};
      
      
      
      
      
      function GotSome(newStr: Str255): BOOLEAN;
         
         var
                 nonZero: BOOLEAN;
                       i: INTEGER;
         
         begin { GotSome}
            nonZero := FALSE;
            for i := 1 to length(newStr) do
               nonZero := NonZero or (newStr[ i ] in [ '1'..'9' ]);
            GotSome := nonZero;
         end {GotSome};
      
      
      
      
      
      procedure TCPDialog;
         
         var
                     Err: OsErr;
         
         
         
         
         
         procedure WS(S: Str255);
            
            begin { WS}
               FailTCP(TCPWriteString(S), TCPWriteErrStr);
            end {WS};
         
         
         
         
         
         
         begin { TCPDialog}
            Err := TCPTimeOuts(NameLookupTimeoutSeconds, ConnectTimeOutSeconds,
               IOTimeOutSeconds);
            FailTCP(TCPInit(Config.serverName), TCPInitErrStr);
            FailTCP(TCPConnect(thePopService, thePopPort), TCPConnErrStr);
            FailTCP(TCPReadString(S), TCPReadErrStr);
            WS(concat(inqPop, ' ', Config.userName));
            FailTCP(TCPReadString(S), TCPReadErrStr);
            WS(quitPop);
            Err := TCPClose;
         end {TCPDialog};
      
      
      
      
      
      
      begin { CheckMail}
         GetSettings(SettingsLoaded);
         iCanSee := SettingsLoaded;
         if iCanSee
         then
            begin {debugstr('i can see');}
               TCPDialog;
               HaveMail := GotSome(s);
               if HaveMail
               then
                  SetMsg(NagStr)
               else
                  SetMsg(NoMailStr);
            end
         else
            begin {debugstr('I CANNOT see' );}
               SetMsg(ButImBlindStr);
               HaveMail := FALSE;
            end;
      end {CheckMail};
   
   
   
   
   
   
   begin { CheckForMail}
      CheckMail(YouHaveSomeNewMail);
      if YouHaveSomeNewMail then
         begin
            if Config.Blatant = 1
            then
               Loops := 1
            else
               Loops := MaxLoops;
            NextTime := TickCount;
         end;
      lastTime := TickCount;
   end {CheckForMail};




procedure HandleEvents( Pause: integer );
   
   var
           myEvent: EventRecord; {information about an event}
   
   
   
   
   
   procedure DoCommand(mResult: LONGINT);
{ Execute command specified by mResult, the result of MenuSelect }
      
      var
              theItem: INTEGER; {menu item number from mResult low-order word}
              theMenu: INTEGER; {menu number from mResult high-order word}
      
      
      
      
      
      procedure DoAppleM;
         
         var
                    name: Str255; {desk accessory name}
                    temp: INTEGER;
         
         begin {DoAppleM}
            if theItem = AboutMeItem
            then
               ShowAboutMeDialog
            else
               begin
                  GetItem(myMenus[ AppleM ], theItem, name);
                  temp := OpenDeskAcc(name);
               end;
         end {DoAppleM};
      
      
      
      
      
      procedure DoFileM;
         
         begin {DoFileM}
            doneFlag := TRUE;
         end {DoFileM};
      
      
      
      
      
      procedure DoEditM;
         
         begin {DoEditM} {Call Desk Manager to handle editing command if desk accessory} {window is the active  window}
            if not SystemEdit(theItem - 1) then
               begin {applic. window is the active window}
               end; {if}
         end {DoEditM};
      
      
      
      
      
      procedure DoOptionsM;
         
         var
               theDialog: DialogPtr;
         
         
         
         
         
         procedure SetText(itemNo: INTEGER; var s: Str255; selectIt: BOOLEAN);
            
            var
                         iT: INTEGER;
                         iH: Handle;
                         iR: Rect;
            
            begin { SetText}
               GetDItem(theDialog, itemNo, iT, iH, iR);
               SetIText(iH, s);
               if selectIt then
                  SelIText(theDialog, itemNo, 0, 32767);
            end {SetText};
         
         
         
         
         
         procedure GetText(itemNo: INTEGER; var s: Str255);
            
            var
                         iT: INTEGER;
                         iH: Handle;
                         iR: Rect;
            
            begin { GetText}
               GetDItem(theDialog, itemNo, iT, iH, iR);
               GetIText(iH, s);
            end {GetText};
         
         
         
         
         
         procedure DoSetup(var server, user: Str255);
            
            const
                     UName = 6;
                     SName = 7;
               itemBlatant = 8;
            
            var
                    itemHit: INTEGER;
                        ity: integer;
                          H: ControlHandle;
                        Box: Rect;
            
            
            
            
            
            procedure UpdateSettingsFile;
               
               var
                             f: text;
                           Err: OsErr;
               
               
               
               
               
               procedure PutI(V: longint);
                  
                  var
                                T: Str255;
                  
                  begin { PutI}
                     NumToString(V, T);
                     PutLine(T);
                  end {PutI};
               
               
               
               
               
               
               begin {UpdateSettingsFile}
                  if not Exists(SysFolderRefNum, fNStr) then
                     CreateSettingsFile;
                  OpenOut(SysFolderRefNum, fNStr);
                  if FileError = NoErr then
                     begin
                        with Config do
                           begin
                              PutLine(OKPassword);
                              PutLine(UserName);
                              PutLine(serverName);
                              PutI(Blatant);
                           end;
                        CloseOut;
                     end;
               end {UpdateSettingsFile};
            
            
            
            
            
            
            begin { DoSetup}
               with Config do
                  begin
                     theDialog := GetNewDialog(SetStatID, NIL, WindowPtr(-1));
                     SetText(SName, server, TRUE);
                     SetText(UName, user, FALSE);
                     GetDItem(theDialog, ItemBlatant, ity, Handle(H), Box);
                     SetCtlValue(H, 1 - Blatant);
                     repeat
                        ModalDialog(NIL, itemHit);
                        if ItemHit = ItemBlatant then
                           SetCtlValue(H, 1 - GetCtlValue(H));
                     until itemHit in [ OK, Cancel ];
                     if itemHit = OK then
                        begin
                           GetText(SName, server);
                           GetText(UName, user);
                           Blatant := 1 - GetCtlValue(H);
                           iCanSee := (server <> '') and (user <> '');
                           if iCanSee
                           then
                              begin
                                 lastTime := 0;
                                 SetMsg(NothingYetStr);
                              end
                           else
                              lastTime := TickCount;
                        end;
                     DisposDialog(theDialog);
                     UpdateSettingsFile;
                  end;
            end {DoSetup};
         
         
         
         
         
         procedure DoShowStatus(var serverName, userName: Str255);
            
            var
                    itemHit: INTEGER;
                  theDialog: DialogPtr;
            
            begin { DoShowStatus}
			CheckForMail;
               theDialog := GetNewDialog(ShowStatID, NIL, WindowPtr(-1));
               ParamText(userName, serverName, msg, '');
               repeat
                  ModalDialog(NIL, itemHit)
               until itemHit = OK;
               DisposDialog(theDialog);
            end {DoShowStatus};
         
         
         
         
         
         
         begin {DoOptionsM}
            with Config do
               case theItem of
                  SetUpItem:
                     DoSetup(serverName, userName);
                  ShowStatusItem:
                     DoShowStatus(serverName, userName);
               end;
         end {DoOptionsM};
      
      
      
      
      
      
      begin {DoCommand}
         theItem := LoWord(mResult);
         theMenu := HiWord(mResult);
         case theMenu of
            AppleID:
               DoAppleM;
            FileID:
               DoFileM;
            EditID:
               DoEditM;
            OptionsID:
               DoOptionsM;
         end; {of menu CASE}
         HiliteMenu(0);
      end {DoCommand};
   
   
   
   
   
   procedure DoKeyDown;
      
      var
              theChar: char;
      
      begin {DoKeyDown}
         theChar := CHR(BitAnd(myEvent.message, charCodeMask)); {get the char}
         if BitAnd(myEvent.modifiers, cmdKey) <> 0 then
            DoCommand(MenuKey(theChar))
      end {DoKeyDown};
   
   
   
   
   
   procedure DoMouseDown;
      
      var
          whichWindow: WindowPtr;
{mouse button down: call Window Mgr to find out where}
      
      begin { DoMouseDown}
         case FindWindow(myEvent.where, whichWindow) of
            inSysWindow:
               SystemClick(myEvent, whichWindow);
            inMenuBar:
               DoCommand(MenuSelect(myEvent.where));
            inContent:;
         end; {of CASE}
      end {DoMouseDown};
   
   
   
   
   
   
   begin { HandleEvents}
      if WaitNextEvent(EveryEvent, myEvent, Pause, NIL) then
         begin
            case myEvent.what of
               MouseDown:
                  DoMouseDown;
               keyDown, autoKey:
                  DoKeyDown;
               activateEvt:;
               updateEvt:;
            end;
         end;
   end {HandleEvents};





procedure RePost;
   
   begin { RePost}
      if Loops > 0 then
         begin
            NextTime := TickCount;
            SetNotify;
            Loops := Loops - 1;
         end;
   end {RePost};





procedure CheckAndPost;
   
   begin { CheckAndPost}
      if NotifyQueueElement.nmRefCon = 0 then
         begin { dsi( 'tickcount = ', tickcount );
		dsi( 'lastime = ', lasttime ); }
            if TickCount - lastTime > sleepTime then
               CheckForMail;
         end;
      if TickCount > NextTime + LoopTime then
         RePost;
   end {CheckAndPost};






begin {main program}
   Initialize;
   UnLoadSeg(@ Initialize);
   repeat
      CheckAndPost;
      HandleEvents( SleepTicks );
   until doneFlag;
   Terminate;
end {Nag}.
