(* K.A.P.
  AwaitLine only returns true or false, and doesn't pass any error
  conditions up the line.  As a result, A non-functioning pop server
  can't be differentiated from an illegal User ID or Password.
*)

{---
  (C) Copyright 1989 Regents of the University of Minnesota

  Permission to use, copy, modify, and distribute this program
  for any purpose and without fee is hereby granted, provided
  that this copyright and permission notice appear on all copies
  and supporting documentation, the name of University of Minnesota
  not be used in advertising or publicity pertaining to distribution
  of the program without specific prior permission, and notice be
  given in supporting documentation that copying and distribution is
  by permission of the University of Minnesota.
  The University of Minnesota makes no representations about
  the suitability of this software for any purpose.  It is provided
  "as is" without express or implied warranty.
---}
     
{$SETC  IBM_TURBO  := False }
{$SETC  Macintosh  := True }
{$SETC  Secure_PW  := True }
{$SETC  ShortCalls  := True }


unit NetMail;

interface
uses
{$IFC IBM_TURBO}

   MacUnit, IBMTCP, Header;


{$ELSEC}  {Mac Version}
       MemTypes,
      QuickDraw,
         OsIntf,
       ToolIntf,
       PackIntf,
     MacTCPIntf,
         FileIo,
             bh,
           Util;
{$ENDC}

type
 NameArrayType = array [ 1..10 ] of Str255;
(*
Error codes:

TCPInit: (and InitMail)
	host unknown		-1

TCPconnect: (and sendmail, donetvalidate)
	cant open socket	-2
	cant bind socket->port	-3
	cant connect to service	-4
	fdopen error		-5
	cant gem memory for buffers and such -17

TCPRead:	Returns # of bytes read (no errors possible???)

TCPClose:	No Errors possible

TCPWrite:
	Error in sending	-7

DoNetValidate:
	TCPConnect errors...
	Invalid login		-8
	Didnt get initial +	-13
	Didnt get #		-14
	Number of Messages	if > 0
	
GetMail:
	didnt get = for read	-9
	Zero length message	-10
	No Memory for msg body	-11
	didnt get = for ackd	-12

SendMail:
	TCPConnect Errors...
	Unexpected response	-15 and text in "ErrorMessage"

PMail "INitialize":
	Cant get global memory	-16
*)




{$IFC IBM_TURBO}
function InitMail(MachineName : string {in};
               var PB : ParamBlock {in}) : OsErr;
function CloseAdapter : OsErr;
{$ELSEC}
function InitMail      ( machinename: str255 ): OsErr;
{$ENDC}
function DoNetValidate( UserName, UserPWD: Str255; var NetServerName: Str255 ): OsErr;
function GetMail       ( Index: integer; var H: Handle; var EnclPath: Str255 ):
   OsErr;
function SendMail      ( var MachineName, FromName, FullName, TheDate: Str255;
   NameHandle: Handle; MsgHandle: Handle ): OsErr;
function PopTerminate( NormalTerminate: boolean ):  OsErr;
function NetTerminate:  OsErr;
procedure FetchErrorMessage    ( var S: Str255 );





implementation

{$IFC IBM_TURBO}

function TCPClose : OsErr;
{Added by K.A.P. since we don't want tcpclose in IBMTCP}

  begin
    TCPClose := IBMTCP.TCPCloseConn;
  end;

procedure SpinOurCursor(n:integer);
  begin
  end;

function Ord4 (H : Handle) : Pointer;
  begin
     Ord4 := Ord( H );
  end;
  
function FSRead(F : integer; Count : longint; Buf : pointer) : OsErr;
  begin
  end;
  
procedure InitBinHex;
  begin
  end;
  
procedure BinToHex(n:integer; F : Str255; X : pointer);
  begin
  end;
  
function FSOpen(Fn : Str255; i : word; F : integer) : integer;
  begin
  end;
  
function FSClose(F : integer) : integer;
  begin
  end;
  
function BitAnd(x,y : longint) : longint;
  begin
    BitAnd := x and y;
  end;
  
function BitXor (x,y : longint) : longint;
  begin
    BitXor := x xor y;
  end;
  
function BitShift(T : longint; n : integer) : longint;
  begin
    if n > 0
      then T := T shl n
      else T := T shr (abs(n));
  end;
  
procedure RDH(Procaddress : pointer {@ InProc}; var Status : Str255; var {?} EnclPath : Str255);
  begin
  end;
  
procedure NumToString(Index : integer; var T :Str255);
  begin
    str (Index, T);
  end;
  
function TickCount : longint;
  begin
  end;
  
  
procedure StringToNum( S : string; var N : longint);
  var
    Code : integer;
  begin
    Val (S, N, Code);
    if Code <> 0 then
      begin
        writeln ('Error in StringToNum');
        HALT;
      end;
  end;



const
  NoErr = 0;
var
  OutLn : string;
  Spincount : integer;
  GLOBIN : char;
  FileEOF: boolean;

{$ENDC}

const
         Debug = false;
    DefPopPort = 109;
  SENDMAILPORT = 25;
           Tab = 9;
            LF = 10;
            CR = 13;
      SLevelID = 'SECURITYLEVEL';
        SKeyID = 'KEY';
    SLEVELNONE = '1';
     SLEVELXOR = '2';
     SLEVELDES = '3';
     SLEVELRNX = '4';
	       Eff = Chr( 196 );
	       Bee = Chr( 167 );
BinHexAllowed = true;  {  set this to false, kim }

type
           pac = packed array [ 1..32000 ] of char;
          CPtr = ^pac;
          PACP = ^PAC;
        JmpBuf = array[1..30] of longint;
        CharH = ^PACP;

var
      LastTicks,
     OLastTicks: longint;
         MsgLen: longint;
   ErrorMessage: String[ 150 ];
      GlobalErr: OsErr;
        PopPort: longint;
           cccc: integer;
    AckDPending: boolean;
             fp: integer;
			 FullUName: String[100];
           Save: jmpBuf;



{$IFC Macintosh }
{$I Options.p }

{$S NetMail }

function __setjmp( var SaveState: JmpBuf ): longint;  c; external ;

procedure longjmp( State: JmpBuf; param: longint ); c; external;

{$ENDC}


{$IFC	Secure_PW }
   procedure desinit; c; external;
   procedure setkey(P: UnivPtr); c; external;
   procedure endes(P: UnivPtr); c; external;
   procedure dedes(P: UnivPtr); c; external;
   procedure desdone; c; external;
{$ENDC}

{$IFC IBM_TURBO }
type
   UnivPtr = Pointer;


{$F+}
function __SetJmp( var J:JmpBuf): integer;
   external;

procedure LongJmp( var J:JmpBuf; x: integer);
   external;

{$L GoTo.obj}

{$IFC ShortCalls}
{$F-}
{$ENDC}


{$ENDC}


procedure GoJmp;
begin
    longjmp( Save, 9999 );
end;


{$IFC Macintosh}



procedure Defer;

   var
                Ev: EventRecord;

   begin { Defer}
{----
      if EventAvail(everyEvent, Ev) then
         ;
	 ----}
   end {Defer};

{$ELSEC}
  procedure Defer;
    begin
    end;
{$ENDC}



procedure OutFL;
   
   begin { OutFL}
      GlobalErr := TCPWriteStringV( OutLn );
      SpinOurCursor( +1 );
   end {OutFL};





procedure SendV( var S: Str255 );
   
   begin { Send}
      GlobalErr := TCPWriteStringV( S );
   end {Send};





procedure Send( S: Str255 );
   
   begin { Send}
      GlobalErr := TCPWriteString( S );
   end {Send};





procedure Send2( S1, S2: Str255 );
   
   begin { Send2}
      Send( concat( S1, S2 ) );
   end {Send2};





procedure FetchErrorMessage( var S: Str255 );

   begin { FetchErrorMessage}
      S := ErrorMessage;
   end {FetchErrorMessage};





function SendMail( var MachineName, FromName, FullName, TheDate: Str255;
   NameHandle: Handle; MsgHandle: Handle ): OsErr;
   
   var
               Err,
              Err2,
           SendErr: OsErr;
                 i,
                 m: integer;
             GLine: Str255;
            NameOK: boolean;
   

   
   
   
   function GetStatus( Code: Str255 ): boolean;
      
      var
                  Err: OsErr;

      begin { GetStatus}
         Defer;
         repeat
            Err := TCPReadString( GLine );
            if Err >= NoErr
            then
               begin
                  GetStatus := Pos( Code, GLine ) = 1;
               end
            else
               begin
                  GetStatus := false;
                  GLine := '*** Error while reading from network.';
               end;
         until GLine[ 4 ] = ' ';
      end {GetStatus};

   
   
   

   procedure BombOut;
      
      begin { BombOut}
         Err := TCPClose;
         SendMail := -15 { Bad status... };
         ErrorMessage := concat( ErrorMessage, ',', GLine );
         GoJmp;
      end {BombOut};
   
   
   
   

   procedure NeedStatus( Needed: Str255 );
      
      var
                  Err: OsErr;
      
      begin { NeedStatus}
         if not GetStatus( Needed ) then
            BombOut;
      end {NeedStatus};
   
   
   
   
   
   procedure FetchString( H: Handle; var S: Str255; var Index: longint );
const
{$IFC IBM_TURBO}
   MaxArraySize = 65000;
{$ELSEC}
   MaxArraySize = 20000000;
{$ENDC}
   
      type
               CharA = packed array [ 1..MaxArraySize ] of char;
               CharP = ^CharA;
               CharH = ^CharP;

      var
                    i,
               StrLen: integer;
                 Size,
                    p: longint;
                   Ch: char;
      
      begin { FetchString}
         Size := GetHandleSize( H );
         if CharH( H ) ^^ [ Size - 1 ] = Chr( 0 ) then
            Size := Size - 1;
         p := Index;
         S := '';
         if p < Size
         then
            begin
               while ( p < Size ) and ( CharH( H ) ^^ [ p ] <> chr( cr ) ) do
                  p := p + 1;
               StrLen := p - Index;
               if StrLen > 255 then
                  StrLen := 255;
{$IFC IBM_Turbo}
               Move( CharH( H ) ^^ [ Index ], S[ 1 ], StrLen );
{$ELSEC}
               BlockMove( UnivPtr( Ord4( H ^ ) +Index - 1 ), UnivPtr( Succ( Ord4( @ S ) ) ),
                  StrLen );
{$ENDC}
               S[ 0 ] := Chr( StrLen );
               Index := p + 1;
            end
         else
            begin
               S := '';
               Index := 0;
            end;
      end {FetchString};
   
   

   
   
   procedure CleanString( var S: Str255 );

      var
                    i: integer;
                   Ch: char;
      
      begin { CleanString}
         for i := 1 to Length( S ) do
            begin
               Ch := S[ i ];
               if ( Ch < ' ' ) or ( Ch > '~' ) then
                  if Ch <> Chr( Tab ) then
                     if Ch <> Eff then
                        if Ch <> Bee then
                           S[ i ] := ' ';
            end;
      end {CleanString};
   

   
   
   
   procedure Assert6( OK: boolean; Errc: integer );

      begin { Assert6}
         if not OK then
            begin
               SendMail := ErrC;
               GoJmp;
            end;
      end {Assert6};
   
   
   

   
   procedure SendX( var T: Str255 );
      


      
      
      function SendFile( Fn: str255 ): integer;
         
         const
                BufSize = 2048;

         var
                       F,
                       p: integer;
                     Err: OsErr;
                   count,
                      bp: longint;
                     TextFileEOF: boolean;
                     Buf: packed array [ 1..BufSize ] of char;
                      Ch: char;
                       L: Str255;
         
         


         
         procedure GetStr( var S: Str255 );
            
            var
                       Done: boolean;
                        Len: integer;

            
            

            
            procedure ReadCh;
               
               
               

               
               procedure RefillBuffer;
                  
                  var
                              Err: OsErr;
                  
                  begin { RefillBuffer}
                     Count := BufSize;
                     Err := FSRead( F, Count, @ Buf );
                     bp := 0;
                  end {RefillBuffer};

               
               

               
               
               begin { ReadCh}
                  if Count <= 0 then
                     RefillBuffer;
                  TextFileEOF := Count = 0;
                  if not TextFileEOF then
                     begin
                        Count := Count - 1;
                        bp := bp + 1;
                        Ch := Buf[ bp ];
                     end;
               end {ReadCh};
            
            
            


            
            begin { GetStr}
               Len := 0;
               repeat
                  ReadCh;
                  Done := ( Ch = chr( 13 ) ) or TextFileEOF;
                  if not Done then
                     if Len < 255 then
                        begin
                           len := len + 1;
                           S[ len ] := Ch;
                        end;
               until Done;
               S[ 0 ] := Chr( Len );
            end {GetStr};
         
         
         
         
         
         procedure SendMacFile( F: Str255 );
            
            begin { SendMacFile}
               SpinCount := 0;
               InitBinHex;
               BinToHex( 0, F, @ OUTFL );
            end {SendMacFile};
         
         

         
         
         procedure SendTextFile;

            begin { SendTextFile}
               if Fn[ 1 ] = ' ' then
                  Delete( Fn, 1, 1 );
               Err := FSOpen( Fn, 0, F );
               if Err = NoErr then
                  begin
                     count := 0;
                     SpinCount := 0;
                     repeat
                        GetStr( L );
                        SpinOurCursor( +1 );
                        SendX( L );
                     until TextFileEOF;
                     Err := FSClose( F );
                  end;
            end {SendTextFile};


         

         procedure SendMacSound;
 
{$IFC IBM_TURBO}
begin
end;
{$ELSEC}
           
            var
                          H: Handle;
                        Ref: integer;
                         Fn: Str255;
                        Err: integer;

            
            

            
            procedure SetFT;

               var
                            FF: FInfo;

               begin { SetFT}
                  with FF do
                     begin
                        fdType := 'SNDP';
                        fdCreator := 'SNDP';
                        fdFlags := 0;
                        with fdLocation do
                           begin
                              h := 0;
                              v := 0;
                           end;
                        fdFldr := 0;
                     end;
                  Err := SetFInfo( Fn, 0, FF );
               end {SetFT};
            
            

            


            begin { SendMacSound}
               Fn := 'Sound';
               H := GetNamedResource( 'snd ', 'blob' );
               if H <> NIL then
                  begin
                     DetachResource( H );
                     CreateResFile( Fn );
                     SetFT;
                     Ref := OpenResFile( Fn );
                     if Ref <> -1 then
                        begin
                           AddResource( H, 'snd ', 1, 'blob' );
                           SetResAttrs( H, ResPurgeable );
                           ChangedResource( H );
                           CloseResFile( Ref );
                           SendMacFile( Fn );
                           Err := FSDelete( Fn, 0 );
                        end;
                  end;
            end {SendMacSound};

{$ENDC}
         


         begin { SendFile}
            p := Pos( Eff, Fn );
            Delete( Fn, 1, p );
            if Fn[ Length( Fn ) ] = ')' then
               Delete( Fn, Length( Fn ), 1 );
            if Fn[ 1 ] = Eff
            then
               begin
                  Delete( Fn, 1, 2 );
                  SendMacFile( Fn );
               end
            else
               if Fn[ 1 ] = Bee
               then
                  SendMacSound
               else
                  SendTextFile;
            SendFile := Err;
         end {SendFile};
      
      
      
      
      
      procedure SendL;

         begin { SendL}
            if T = '.' then
               T := '..';
            CleanString( T );
            SendV( T );
         end {SendL};
      
      

      
      
      
      begin { SendX}
         if Length( T ) = 0
         then
            SendV( T )
         else
            if T[ 1 ] = 'E'
            then
               if Pos( 'Enclosure', T ) = 1
               then
                  SendErr := SendFile( T )
               else
                  SendL
            else
               SendL;
      end {SendX};
   
   

   
   
   procedure OldFetchUserName;

      begin { FetchUserName}
         Send2( 'vrfy ', FromName );
         NameOK := GetStatus( '250' );
         if NameOK
         then
            begin
               Delete( GLine, 1, 4 );
               if Pos( '|', GLine ) > 0
               then
                  FullName := FromName
               else
                  FullName := GLine;
            end
         else
            begin
               if Pos( '550', GLine ) = 1
               then
                  BombOut { name is not OK! }
               else
                  FullName := FromName;
            end;
      end {FetchUserName};
   
   
   
   
   
   procedure FetchUserName;

      begin { FetchUserName}
         FullName := FullUName;
         if FullName = '' then
            OldFetchUserName;
      end {FetchUserName};

   
   

   
   procedure Prelims;
   
   procedure GetOurIP( var IP: Str255 );
   var i, t: integer; TS: Str255; C: char;
   begin
     IP := '[';
	 for i := 3 downto 0 do
	 begin
	   t := BitAnd( BitShift( OurIPAddress, - i * 8 ), $FF );
	   NumToString( T, TS );
	   IP := concat( IP, TS );
	   if i = 0 then C := ']' else C := '.';
	   IP := concat( IP, C );
	 end;
   end;
   
           
      begin { Prelims}
         Err := TCPconnect( 'smtp', SENDMAILPORT );
         Assert6( Err = NoErr, Err );
         NeedStatus( '220' );
		 GetOurIP( MachineName );
         Send2( 'helo ', MachineName );
         NeedStatus( '250' );
         if FullName = '' then
            FetchUserName;
         Send2( 'mail from:<', concat( FromName, '>' ) );
         NeedStatus( '250' );
         ErrorMessage := '';
      end {Prelims};
   
   
   
   
   procedure SendRCPTs;
      
      var
                    T: Str255;
                   Hp: longint;

      begin { SendRCPTs}
         Hp := 1;
         repeat
            FetchString( NameHandle, T, Hp );
            if Hp > 0 then
               begin
                  Send2( 'rcpt to:', T );
                  if not GetStatus( '250' ) then
                     begin
                        T := ' ';
                        T[ 1 ] := chr( cr );
                        ErrorMessage := concat( ErrorMessage, GLine, T );
                        Err := -15;
                     end;
               end;
         until Hp = 0;
      end {SendRCPTs};
   
   


   
   procedure SendData;
      
      var
                    T: Str255;
                   HP: longint;

      begin { SendData}
         Send( 'data' );
         NeedStatus( '354' );
         Send2( 'Date: ', TheDate );
         Send2( 'From: ', FullName );
         HLock( MsgHandle );
         Hp := 1;
         repeat
            FetchString( MsgHandle, T, Hp );
            if Hp > 0 then
               SendX( T );
         until ( GlobalErr < NoErr ) or ( Hp = 0 );
         Assert6( GlobalErr >= NoErr, GlobalErr );
         HUnLock( MsgHandle );
         Send( '.' );
      end {SendData};
   
   
   
   

   procedure Finish;
      
      begin { Finish}
         NeedStatus( '250' );
         Send( 'quit' );
         NeedStatus( '221' );
         Err2 := TCPClose;
         if Err2 <> NoErr then
            Err := Err2;
      end {Finish};
   
   


   

   begin { SendMail}
      if __setjmp( Save ) = 0 then
         begin
            Prelims;
            SendRCPTS;
            SendDATA;
            Finish;
            SendMail := Err;
         end;
   end {SendMail};



function AwaitLine( c: char; var GLine: Str255 ): boolean;

   var
               Err: OsErr;
                OK: boolean;

   begin { AwaitLine}
      Defer;
      Err := TCPReadString( GLine );
      if Err >= NoErr
      then
         begin
            if GLine[ 1 ] = chr( lf ) then
               Delete( GLine, 1, 1 );
            OK := GLine[ 1 ] = c;
         end
      else
         OK := false;
      if not OK then
         begin
{debugstr(concat('expected: "', c, '"  got "', gline));}
{OK := AwaitLine(c, GLine);}
         end;
      AwaitLine := OK;
   end {AwaitLine};





function GetNetChar( var c: char ): OsErr;

   begin { GetNetChar}
      if MsgLen > 0
      then
         begin
            GetNetChar := TCPReadChar( c );
            MsgLen := MsgLen - 1;
         end
      else
         begin
            GetNetChar := -9999;
            c := '?';
         end;
   end {GetNetChar};





procedure InProc;
   
   var
               Err: OsErr;
   
   begin { InProc}
      Err := GetNetChar( GLOBIN );
      NetworkEOF := Err <> NoErr;
      cccc := cccc + 1;
      if cccc > 100 then
         begin
            SpinOurCursor( -1 );
            cccc := 0;
         end;
   end {InProc};


function GetMail( Index: integer; var H: Handle; var EnclPath: Str255 ): OsErr;

   var
              Msgs,
                 m: longint;
               Err: OsErr;
                 T,
                GL: Str255;
                 i: longint;
                Ch: char;
              fpat: String[ 80 ];
   

   
   
   
   procedure Assert5( OK: boolean; Errc: integer );

      begin { Assert5}
         if not OK then
            begin
               GetMail := ErrC { Didnt get expected something };
               ErrorMessage := GL;
               GoJmp;
            end;
      end {Assert5};
   
   


   
   procedure FinishUp;
      
      begin { FinishUp}
         if AckDPending then
            begin
               Send( 'ackd' );
               Assert5( awaitline( '=', GL ), -12 );
               AckDPending := false;
            end;
      end {FinishUp};



   procedure GetNextSegment;

      const
       MaxPartLength = 5000;

      var
           PartLength: longint;
      

      
      
      
      procedure ActualRead;

         label
                       1;
         
         var
                      ip,
                      op,
                     sop: longint;
                       T: Str255;
         
         


         
         procedure SaveChar( Ch: char );
            
            begin { SaveChar}
               op := op + 1;
               CharH( H ) ^^ [ op ] := Ch;
            end {SaveChar};




         
         procedure SaveStr( S: Str255 );

            var
                          i: integer;
            
            begin { SaveStr}
               for i := 1 to Length( S ) do
                  SaveChar( S[ i ] );
            end {SaveStr};
         
         
         


         procedure AbsorbFile;
            
            var
                     Status: Str255;
            
            begin { AbsorbFile}
               if op > sop then
                  op := sop;
               InitBinHex;
               cccc := 0;
               RDH( @ InProc, Status, EnclPath );
               SaveStr( Status );
               fp := 1;
               sop := -1;
            end {AbsorbFile};

         
         
         


         begin { ActualRead}
            AckDPending := false;
            Err := NoErr;
            HLock( H );
            Defer;
            op := 0;
            sop := -1;
            for ip := 1 to PartLength do
               begin
                  if MsgLen <= 0 then
                     goto 1;
                  Err := GetNetChar( Ch );
                  if Err <> NoErr then
                     goto 1;
                  if BinHexAllowed and (Ch = fpat[ fp ])
                  then
                     begin {debugstr( concat('match ', Ch ) );}
                        if sop = -1 then
                           sop := op;
                        fp := fp + 1;
                        if fp > Length( fpat ) then
                           AbsorbFile;
                     end
                  else
                     begin
                        if fp > 1
                        then {debugstr( concat( 'Broke match ', Ch ) )}
                           ;
                        fp := 1;
                        sop := -1;
                     end;
                  if Ch <> chr( LF ) then
                     SaveChar( Ch );
               end;
         1: SaveChar( chr( 0 ) );
            HUnLock( H );
            if fp > 8 then
               if sop > 0 then
                  if op > sop then
                     op := sop;
            SetHandleSize( H, op );
            Defer;
         end {ActualRead};






      begin { GetNextSegment}
         PartLength := MsgLen;
         if PartLength > MaxPartLength then
            PartLength := MaxPartLength;
         H := NewHandle( PartLength + 5 {1} );
         if H = NIL
         then
            Err := -11 { No mem for message !! }
         else
            if PartLength = 0
            then
               begin
                  CharH( H ) ^^ [ 1 ] := chr( 0 );
{$IFC IBM_TURBO}
                  SetHandleSize (H, 0);  {ADDED by K.A.P. 2/13/90}
{$ENDC}
                  AckDPending := true;
                  Err := NoErr;
               end
            else
               ActualRead;
      end {GetNextSegment};


   procedure PrimeInput;


      procedure AskForMail;
         
         var
                     Err: OsErr;

         begin { AskForMail}
            Send( 'retr' );
            Err := TCPFlushBuffer;
            Defer;
         end {AskForMail};
      

      


      procedure PrimeThePump;

         begin { PrimeThePump}
            FinishUp;
            NumToString( Index, T );
            Send2( 'read ', T );
            Assert5( awaitline( '=', GL ), -9 );
            Delete( GL, 1, 1 );
            StringToNum( GL, msglen );
         end {PrimeThePump};


      
      
      
      
      begin { PrimeInput}
         fpat := '(This file must be converted with ';
         ErrorMessage := '';
         if Index > 0 then
            begin
               fp := 1;
               PrimeThePump;
               if msglen = 0
               then
                  Err := -10 { zero length for this msg! }
               else
                  AskForMail;
            end;
      end {PrimeInput};
   
   

   begin { GetMail}
      if __setjmp( Save ) = 0 then
         begin
            PrimeInput;
            GetNextSegment;
            GetMail := Err;
         end;
   end {GetMail};


{$IFC IBM_TURBO}
function InitMail(MachineName : string {in};
               var PB : ParamBlock {in}) : OsErr;
{$ELSEC}
function InitMail( machinename: str255 ): OsErr;
{$ENDC}
   var
               Err: OsErr;
                 p: integer;
                 S: Str255;
                Po: longint;
   
   begin { InitMail}
      ErrorMessage := '';
      PopPort := DefPopPort;
      p := pos( ' ', machinename );
      if p > 0 then
         begin
            S := machineName;
            Delete( S, 1, P );
            machineName := copy( machineName, 1, p - 1 );
            while ( length( S ) > 1 ) and ( S[ 1 ] = ' ' ) do
               Delete( S, 1, 1 );
            if Length( S ) > 1 then
               begin
                  StringToNum( S, Po );
                  if Po > 0 then
                     PopPort := Po;
               end;
         end;
{$IFC IBM_TURBO}
      Err := TCPInit (PB);
{$ELSEC}
      Err := TCPInit( machinename );
{$ENDC}
      InitMail := Err;  { 0 = Looked up IP on Name Server OK
			  1 = Already Had IP
			  2 = Name Server Connection Timed Out }
   end {InitMail};





function DoNetValidate( UserName, UserPWD: Str255; var NetServerName: Str255 ): OsErr;

   const
            maxwc = 10;
   
   type
            Str20 = string[ 20 ];
   
   var
               Err: OsErr;
              ErrC: longint;
                GL: Str255;
                 W: array [ 1..maxwc ] of str20;
                wc,
                 p: integer;
            TheKey: Str20;
               Pwd: Str255;
      SecurityMode: char;
   
   


   
   procedure HexToNum( V: Str20; var Out: Str20 );
      
      var
                    i,
                    j,
                    T,
                    X: integer;
                    c: char;
      
      begin { HexToNum}
         j := 0;
         T := 0;
         Out := '';
         for i := 1 to Length( V ) do
            begin
               c := V[ i ];
               if c in [ '0'..'9' ]
               then
                  X := Ord( c ) -Ord( '0' )
               else
                  if c in [ 'A'..'Z' ]
                  then
                     X := Ord( c ) -Ord( 'A' ) +10
                  else
                     X := 0;
{*}            T := BitShift( T, 4 ) +X;
               if not Odd( i ) then
                  begin
                     Out := concat( Out, chr( T ) );
                     T := 0;
                  end;
            end;
      end {HexToNum};
   
   
   
   
   
   procedure Assert4( OK: boolean; Errc: integer );

      begin { Assert4}
         if not OK then
            begin
               DoNetValidate := ErrC { Didnt get expected something };
               GoJmp;
            end;
      end {Assert4};
   
   
   
   
   
   procedure SendTheHello;


      
      
      
      procedure SendTimed( S: Str255 );
         
         var
                   Delay,
                 EndTime: longint;
                       i: integer;
                     Err: OsErr;
                       c: array[1..1] of char;
         
         begin { SendTimed}
            for i := 1 to Length( S ) do
               begin
                  c[1] := S[ i ];
                  Delay := ( Ord( c[1] ) mod 15 ) +15;
                  EndTime := TickCount + Delay;
                  repeat
                  until TickCount >= EndTime;
                  Err := TCPWrite( UnivPtr( @c[1] ), 1 ); { test this on Mac and IBM,
				  										"improved" by GRG }
                  Err := TCPFlushBuffer;
               end;
         end {SendTimed};


      

      
      procedure CnvToHex( S: Str255; var Out: str255 );
         
         var
                       i: integer;
                       T: Str20;
                  HexStr: Str20;
         
         
         
         
         
         procedure CnvH( c: char; var S: Str20 );
            
            

            

            function Hx( V: integer ): char;
               
               begin { Hx}
                  Hx := HexStr[ BitAnd( V, $000F ) +1 ];
               end {Hx};
            
            
            

            
            
            begin { CnvH}
               S := concat( Hx( BitShift( Ord( c ), -4 ) ), Hx( Ord( c ) ) );
            end {CnvH};
         

         
         

         
         begin { CnvToHex}
            HexStr := '0123456789ABCDEF';
            Out := '';
            for i := 1 to 8 do
               begin
                  if i <= length( S )
                  then
                     CnvH( S[ i ], T )
                  else
                     T := '00';
                  Out := concat( Out, T );
               end;
         end {CnvToHex};
      
      
      

      
      procedure exxor( v1, v2: Str20; var Out: str255 );

         var
                       i: integer;
                       c: char;
                       T: Str255;

         begin { exxor}
            CnvToHex( V2, T );
            T := '12345678';
            for i := 1 to 8 do
               begin
                  if i <= length( v1 )
                  then
                     c := V1[ i ]
                  else
                     c := ' ';
                  T[ i ] := Chr( BitXor( Ord( c ), Ord( V2[ i ] ) ) );
               end;
            CnvToHex( T, Out );
         end {exxor};
      

      


      procedure despwd( T, v2: Str20; var Out: Str255 );

         var
                       i: integer;
                      TT: packed array [ 1..8 ] of char;
         
         begin { despwd}
{$IFC Secure_PW }
            desinit;
            setkey( UnivPtr( Succ( Ord4( @ V2 ) ) ) );
            for i := 1 to 8 do
               TT[ i ] := T[ i ];
            endes( UnivPtr( @ TT ) );
            DesDone;
            for i := 1 to 8 do
               T[ i ] := TT[ i ];
            CnvToHex( T, Out );
{$ENDC}
         end {despwd};


      
      
      
      procedure GetWords;
         
         var
                       p,
                     lwc: integer;
                       L: Str255;
         
         begin { GetWords}
            L := GL;
            wc := 0;
            repeat
               p := pos( ' ', L );
               if p = 0 then
                  p := length( L ) +1;
               if p = 1
               then
                  delete( L, 1, 1 )
               else
                  begin
                     wc := wc + 1;
                     W[ wc ] := copy( L, 1, p - 1 );
                     delete( L, 1, p );
                  end;
            until ( L = '' ) or ( wc >= maxwc );
            lwc := wc;
            while lwc < maxwc do
               begin
                  lwc := lwc + 1;
                  W[ lwc ] := '';
               end;
         end {GetWords};
      


      

      procedure FormFancyPwd;
         

         
         
         
         procedure PadPW;
            
            begin { PadPW}
               while length( UserPWD ) < 8 do
                  UserPwd := concat( UserPWD, ' ' );
            end {PadPW};
         
         
         
         
         

         begin { FormFancyPwd}
            case SecurityMode of
               SLEVELNONE:
                  pwd := UserPWD;
               SLEVELXOR:
                  begin
                     PadPW;
                     HexToNum( W[ 8 ], TheKey );
                     exxor( UserPWD, TheKey, pwd );
                  end;
               SLEVELDES:
                  begin
                     PadPW;
                     HexToNum( W[ 8 ], TheKey );
                     despwd( UserPwd, TheKey, pwd );
                  end;
               SLEVELRNX:
                  begin
                     PadPW;
                     HexToNum( W[ 8 ], TheKey );
                     despwd( TheKey, UserPwd, pwd );
                  end;
            end;
         end {FormFancyPwd};

      

      
      
      
      begin { SendTheHello}
         Assert4( awaitline( '+', GL ), -13 );
         GetWords; { 1 = +    2 = POP2,   3 = boombox,  4 = server,
			  5 = 'SECURITYLEVEL',  6 = #,
			  7 = 'KEY', 	8 = kkkkkkkkkkkkkkkk
			9 = 'POP2+'}
{$IFC Secure_PW }
         if W[ 5 ] = SLevelID
         then
            begin
               SecurityMode := W[ 6 ] [ 1 ];
               if SecurityMode in [ SLEVELXOR, SLEVELDES, SLEVELRNX ]
               then
                  FormFancyPwd
               else
                  begin
                     pwd := UserPWD;
                     SecurityMode := SLEVELNONE;
                  end;
            end
         else
{$ENDC }
            begin
               Pwd := UserPWD;
               SecurityMode := SLEVELNONE;
            end;
         GL := concat( 'helo ', UserName, ' ', Pwd );
         if SecurityMode > SLEVELNONE then
            GL := concat( GL, ' ', SecurityMode );
         if SecurityMode in [ {-- off for now...  SLEVELNONE, SLEVELXOR  } ]
         then
            begin
               SendTimed( GL );
               Send( '' );
            end
         else
            SendV( GL );
         Assert4( awaitline( '#', GL ), -14 );
         if GL = '#-1'
         then
            DoNetValidate := -8 { not valid! }
         else
            begin
               Delete( GL, 1, 1 );
               FullUName := '';
               p := pos( '$', GL );
               if p > 0 then
                  begin
                     FullUName := GL;
                     Delete( FullUName, 1, p );
                     p := pos( '$', FullUName );
                     if p > 0 then
                        FullUName := Copy( FullUName, 1, p - 1 );
                  end;
               p := pos( ' ', GL );
               if p > 0 then
                  GL := Copy( GL, 1, p - 1 );
               StringToNum( GL, ErrC );
               DoNetValidate := ErrC;
            end;
      end {SendTheHello};

   
   procedure GetNetServerName;
   begin
      Send( 'RELA' );
	  Assert4( awaitline( '+', GL ), -144 );
	  Delete( GL, 1, 2 );
	  NetServerName := GL;
   end;
   
   
   
   begin { DoNetValidate}
      if __setjmp( Save ) = 0 then
         begin
            ErrorMessage := '';
            Err := TCPconnect( 'pop', POPPORT );
            if Err = NoErr
            then
			begin
               SendTheHello;
			   if W[ 9 ] = 'POP2+' then
			     GetNetServerName
				 else
				 NetServerName := '';
		    end
            else
               DoNetValidate := Err { no connect!! };
            AckDPending := false;
         end;
   end {DoNetValidate};


function NetTerminate: OsErr;

   var
                GL: Str255;

   begin { NetTerminate}
      ErrorMessage := '';
      NetTerminate := TCPClose;
   end {NetTerminate};





function POPTerminate( NormalTerminate: boolean ): OsErr;

   var
                GL: Str255;

   


   
   procedure FinishUp;
      
      begin { FinishUp}
         if AckDPending then
            begin
               Send( 'ackd' );
               if awaitline( '=', GL ) then
                  ;
               AckDPending := false;
            end;
      end {FinishUp};



   


   begin { POPTerminate}
      ErrorMessage := '';
	  if NormalTerminate then
	  begin
      FinishUp;
      Send( 'quit' );
      if awaitline( '+', GL ) then
         ;
	  end;
      PopTerminate := TCPClose;
   end {POPTerminate};

{$IFC IBM_TURBO}
function CloseAdapter : OsErr;
  begin
    CloseAdapter := TCPClose;
  end; {CloseAdapter}
{$ENDC}

{$IFC IBM_TURBO }
begin {NetMail}
{$ENDC}

   
end. {NetMail}

