unit TCPDefs;
{---
  (C) Copyright 1989 Regents of the University of Minnesota

  Permission to use, copy, modify, and distribute this program
  for any purpose and without fee is hereby granted, provided
  that this copyright and permission notice appear on all copies
  and supporting documentation, the name of University of Minnesota
  not be used in advertising or publicity pertaining to distribution
  of the program without specific prior permission, and notice be
  given in supporting documentation that copying and distribution is
  by permission of the University of Minnesota.
  The University of Minnesota makes no representations about
  the suitability of this software for any purpose.  It is provided
  "as is" without express or implied warranty.
---}

interface
uses MemTypes, QuickDraw, OsIntf;

{ MacTCP return Codes in the range -23000 through -23049 }

const
    inProgress = 1 { I/O in progress };
   ipBadLapErr = -23000 { bad network configuration };
  ipBadCnfgErr = -23001 { bad IP configuration error };
   ipNoCnfgErr = -23002 { missing IP or LAP configuration error };
     ipLoadErr = -23003 { error in MacTCP load };
     ipBadAddr = -23004 { error in getting address };
connectionClosing = -23005 { connection is closing };
 invalidLength = -23006;
connectionExists = -23007 { request conflicts with existing connection };
connectionDoesntExist = -23008 { connection does not exist };
insufficientResources = -23009 { insufficient resources to perform request };
invalidStreamPtr = -23010;
streamAlreadyOpen = -23011;
connectionTerminated = -23012;
 invalidBufPtr = -23013;
    invalidRDS = -23014;
    invalidWDS = -23014;
    openFailed = -23015;
commandTimeout = -23016;
duplicateSocket = -23017;
{ Error codes from internal IP functions }
 ipDontFragErr = -23032 { Packet too large to send w/o fragmenting };
 ipDestDeadErr = -23033 { destination not responding };
ipNoFragMemErr = -23036 { no memory to send fragmented pkt };
    ipRouteErr = -23037 { can't route packet off= -net };
 nameSyntaxErr = -23041;
    cacheFault = -23042;
  noResultProc = -23043;
  noNameServer = -23044;
   authNameErr = -23045;
      noAnsErr = -23046;
        dnrErr = -23047;
   outOfMemory = -23048;
  BYTES_16WORD = 2 { bytes per 16 bit ip word };
  BYTES_32WORD = 4 { bytes per 32 bit ip word };
  BYTES_64WORD = 8 { bytes per 64 bit ip word };

type
           b_8 = 0..255 { 8-bit quantity };
          b_16 = integer { 16-bit quantity };
          b_32 = longint { 32-bit quantity };
          BPtr = Ptr;
     StreamPtr = BPtr;
       ip_addr = b_32 { IP address is 32-bits };
  ip_addrbytes = record
case boolean of
                              true: (        addr: b_32);
                             false: (        byte: packed array [ 1..4 ] of char);
                end;
   
      wdsEntry = record
                         length: integer { length of buffer };
                            ptr: BPtr { pointer to buffer };
                end;
   
      rdsEntry = record
                         length: integer { length of buffer };
                            ptr: BPtr { pointer to buffer };
                end;
   
 BufferPtrType = BPtr;
 StreamPtrType = BPtr;
   ICMPMsgType = (netUnreach, hostUnreach, protocolUnreach, portUnreach,
                  fragReqd, sourceRouteFailed, timeExceeded, parmProblem,
                  missingOption); {
	lastICMPMsgType = 65535}
   
       ip_port = b_16;
    ICMPReport = record
                      streamPtr: StreamPtrType;
                      localHost: Ip_Port;
                      localPort: ip_Port;
                     remoteHost: Ip_Addr;
                     remotePort: ip_port;
                     reportType: ICMPMsgType;
               optionalAddlInfo: integer;
            optionalAddlInfoPtr: BPtr;
                end;
{ 
	GetMyIPAddr.h	
	Pascal definitions of parameter block entries needed for IP calls

    Copyright Apple Computer, Inc. 1989 
    All rights reserved
	
}

const
ipctlGetAddr	=	15			{ csCode to get our IP address };
type

 IPParamBlock = record
   qLink: BPtr;
   QType: integer;
   iotrap: integer;
   ioCmdAddr: BPtr;
   ioCompletion: BPtr;
   ioResult: OsErr;
   ioNamePtr: StringPtr;
   iovRefNum: integer;
   ioCRefNum: integer;
   csCode: integer;
		ourAddress: ip_addr			{ our IP address };
		ourNetMask	: longint		{ our IP net mask };
end;


{ 
	AddressXlation.h		
	MacTCP name to address translation routines.

    Copyright Apple Computer, Inc. 1988 
    All rights reserved
	
}

const
 NUM_ALT_ADDRS = 4;

type
          CStr = packed array [ 1..256 ] of char;
        StrPtr = ^CStr;
      hostInfo = record
                        rtnCode: longint;
                          cname: CStr;
                           addr: array [ 1..NUM_ALT_ADDRS ] of longint;
                end;
   
   AddrClasses = (FillerAddrClass, A, NS, FillerAddress2, FillerAddress3, CNAME); { lastClass = 65535}
   
cacheEntryRecord = record
                          cname: BPtr;
                          ctype: integer;
                          class: AddrClasses;
                            ttl: longint;
case boolean of
                             false: (        name: StrPtr);
                              true: (        addr: ip_addr);
                end;
   
     hostInfoP = ^hostInfo;
EnumResultProcPtr = BPtr;
 ResultProcPtr = BPtr;






{$I Options.p }


function OpenResolver(fileName: BPtr): OsErr; c;

function StrToAddr(var hostName: CStr; var hostInfoPtr: hostInfo; ResultProc:
   ResultProcPtr; userDataPtr: BPtr): OsErr; c;

function AddrToStr(addr: longint; var addrStr: CStr): OsErr; c;

function EnumCache(enumResultProc: EnumResultProcPtr; userDataPtr: BPtr): OsErr; c;

function AddrToName(addr: ip_addr; hostInfoPtr: hostInfoP; ResultProc:
   ResultProcPtr; userDataPtr: BPtr): OsErr; c;


function GRGOpenResolver(Fn: Str255): OsErr;
function CloseResolver: OsErr; c;
function GRGStrToAddr(HostName: Str255; var rtn: HostInfo; resultproc: longint;
   userdata: Ptr): OsErr;
   
{ 
	Pascal definitions of parameter block entries needed for TCP calls
}
{ Command codes }

const
 TCPDRVRREFNUM = 50;
NumOfHistoBuckets = 7;
     TCPCreate = 30;
TCPPassiveOpen = 31;
 TCPActiveOpen = 32;
       TCPSend = 34;
  TCPNoCopyRcv = 35;
TCPRcvBfrReturn = 36;
        TCPRcv = 37;
      TCPCloze = 38;
      TCPAbort = 39;
     TCPStatus = 40;
TCPExtendedStat = 41;
    TCPRelease = 42;
 TCPGlobalInfo = 43;
     TCPCtlMax = 49;

type
  TCPEventCode = (TCPFiller, TCPClosing, TCPULPTimeout, TCPTerminate,
                  TCPDataArrival, TCPUrgent, TCPICMPReceived); { lastEvent = 65535 }
   
TCPTerminationReason = (TCPFiller2, TCPFiller3, TCPRemoteAbort, TCPNetworkFailure,
                  TCPSecPrecMismatch, TCPULPTimeoutTerminate, TCPULPAbort,
                  TCPULPClose, TCPServiceError); { lastReason = 65535 }
   
      tcp_port = integer;

const
   
{ ValidityFlags }
  timeoutValue = $80;
 timeoutAction = $40;
 typeOfService = $20;
    precedence = $10; { TOSFlags }
      lowDelay = $01;
    throughPut = $02;
   reliability = $04;

type
   TCPCreatePB = record
                        rcvBuff: BPtr;
                     rcvBuffLen: longint;
                     notifyProc: BPtr;
                    userDataPtr: BPtr;
                end;
   
     TCPOpenPB = packed record
                       ulpTimeoutValue: byte;
                      ulpTimeoutAction: byte;
                         validityFlags: byte;
                   commandTimeoutValue: byte;
                            remoteHost: ip_addr;
                            remotePort: tcp_port;
                             localHost: ip_addr;
                             localPort: tcp_port;
                              tosFlags: byte;
                            precedence: byte;
                              dontFrag: Boolean;
                            timeToLive: byte;
                              security: byte;
                             optionCnt: byte;
                               options: packed array [ 1..40 ] of Byte;
                           userDataPtr: BPtr;
                       end;
   
     MyTCPSendPB = {packed} record
                ulpTimeoutValue: byte;
               ulpTimeoutAction: byte;
                  validityFlags: byte;
                       pushFlag: boolean;
                     urgentFlag: boolean;
					   filler99: byte;
                         wdsPtr: BPtr;
                       sendFree: longint;
                     sendLength: integer;
                    userDataPtr: BPtr;
                end;

	TCPSendPB		=		RECORD
		ulpTimeoutValue		:	SignedByte;
		ulpTimeoutAction	:	SignedByte;
		validityFlags		:	SignedByte;
		pushFlag			:	Boolean;
		urgentFlag			:	Boolean;
		wdsPtr				:	Ptr;
		sendFree			:	LongInt;
		sendLength			:	Integer;
		userDataPtr			:	Ptr;
	END;
	
   
  TCPReceivePB = packed record { for receive and return rcv buff calls }
                   commandTimeoutValue: byte {32};
                                filler: byte {33};
                            urgentFlag: boolean {34};
                              markFlag: boolean {35};
                               rcvBuff: BPtr {36};
                            rcvBuffLen: integer {40};
                                rdsPtr: BPtr;
                             rdsLength: integer;
                       secondTimeStamp: integer;
                           userDataPtr: BPtr;
                       end;
   
    TCPClosePB = record
                ulpTimeoutValue: byte;
               ulpTimeoutAction: byte;
                  validityFlags: byte;
                    userDataPtr: BPtr;
                end;
   
   HistoBucket = record
                          value: integer;
                        counter: longint;
                end;
   
TCPConnectionStats = record
                   dataPktsRcvd,
                   dataPktsSent,
                 dataPktsResent,
                      bytesRcvd,
                   bytesRcvdDup,
            bytesRcvdPastWindow,
                      bytesSent,
                    bytesResent: longint;
                numHistoBuckets: integer;
                  sentSizeHisto: array [ 1..NumOfHistoBuckets ] of HistoBucket;
                        lastRTT,
                        tmrSRTT,
                    rttVariance,
                         tmrRTO: integer;
                      sendTries: byte;
               sourchQuenchRcvd: byte;
                end;
   
   TCPStatusPB = packed record
                ulpTimeoutValue,
               ulpTimeoutAction: Byte;
                         unused: longint;
                     remoteHost: ip_addr;
                     remotePort: tcp_port;
                      localHost: ip_addr;
                      localPort: tcp_port;
                       tosFlags,
                     precedence,
                connectionState: Byte;
                     sendWindow,
                      rcvWindow,
                 amtUnackedData,
                  amtUnreadData: integer;
               securityLevelPtr: BPtr; { HEMS-HEMP stats }
                    sendUnacked,
                       sendNext,
               congestionWindow,
                        rcvNext,
                           srtt,
                        lastRTT,
                 sendMaxSegSize: longint;
                    connStatPtr: ^TCPConnectionStats;
                    userDataPtr: BPtr;
                end;
   
    TCPAbortPB = record
                    userDataPtr: BPtr;
                end;
   
      TCPParam = record
                        tcpRtoA,
                      tcpRtoMin,
                      tcpRtoMax,
                  tcpMaxSegSize,
                     tcpMaxConn,
                   tcpMaxWindow: longint
                end;
   
      TCPStats = record
                tcpConnAttempts,
                  tcpConnOpened,
                tcpConnAccepted,
                  tcpConnClosed,
                 tcpConnAborted,
                    tcpOctetsIn,
                   tcpOctetsOut,
                 tcpOctetsInDup,
               tcpOctetsRetrans,
                   tcpInputPkts,
                  tcpOutputPkts,
                     tcpDupPkts,
                 tcpRetransPkts: longint
                end;
   
TCPGlobalInfoPB = record
                    tcpParamPtr: ^TCPParam;
                    tcpStatsPtr: ^TCPStats;
                    tcpCDBTable: ^longint;
                    userDataPtr: BPtr;
                end;
   
       TCPiopb = record
                         fill12: packed array [ 1..12 ] of char;
                   ioCompletion: BPtr {12};
                       ioResult: integer {16};
                      ioNamePtr: StringPtr {18};
                      ioVRefNum: integer {22};
                      ioCRefNum: integer {24};
                         csCode: integer {26};
                      tcpStream: StreamPtrType {28};
case integer of
                                 1: (      create: TCPCreatePB);
                                 2: (        open: TCPOpenPB);
                                 3: (        send: TCPSendPB);
                                 4: (     receive: TCPReceivePB);
                                 5: (       close: TCPClosePB);
                                 6: (       abort: TCPAbortPB);
                                 7: (      status: TCPStatusPB);
                                 8: (  globalInfo: TCPGlobalInfoPB);
                end;


implementation




procedure PToC(var S: Str255; var c: CStr);
   
   var
                 i: integer;
   
   begin { PToC}
      for i := 1 to Length(S) do
         c [ i ] := S[ i ];
      c [ Length(S) ] := chr(0);
   end {PToC};




function GRGStrToAddr(HostName: Str255; var rtn: HostInfo; resultproc: longint;
   userdata: Ptr): OsErr;
   
   
   
   
   
   function StrToAddr(var HostName: CStr; var rtn: HostInfo; resultproc: longint;
      userdata: Ptr): OsErr; c; external;
   
   
   var
                 c: CStr;
   
   begin { GRGStrToAddr}
      PToC(HostName, c);
      GRGStrToAddr := StrToAddr(c, rtn, resultproc, userdata);
   end {GRGStrToAddr};
   
   
function GRGOpenResolver(Fn: Str255): OsErr;
   
   var
                 C: CStr;   
   
   begin { GRGOpenResolver}
   if Fn = '' then
    GRGOpenResolver := OpenResolver( NIL )
	else
	begin
      PToC(Fn, C);
      GRGOpenResolver := OpenResolver( BPtr(@C) );
	end;
   end {GRGOpenResolver};


end.
