
unit bh;
{  $U FileIo }
interface
uses
       MemTypes,
      Quickdraw,
         OsIntf,
       ToolIntf,
       PackIntf,
         FileIo;

type
   UnivPtr = Ptr;

var
          OutLn: Str255;
         GLOBIN: char;
     NetworkEOF: boolean;



procedure InitBinHex;
procedure BinToHex     (iv: integer; ifn: Str255; OutProc: ProcPtr);
procedure RDH  (INPRC: ProcPtr; var ErrCode: Str255; var EPath: Str255);





implementation

const
         debug = false;
         prt = false;
    EscapeChar = $90;
            CR = 13;
       DirName = 'Incoming';

type
         Str80 = string[ 80 ];

var
            CRC: integer;
            Err: Integer;
            MBF: longint;
       LastChar: char;
       RepCount: integer;
         EncVec: Str80;
        EncRVec: packed array [ 0..255 ] of 0..100;
          Outcc,
          OBits,
           OutW,
            Rep: integer;
          LastC: integer;
         InBits,
            InW: integer;
{$I Options.p }






function BtAnd(X, Y: longint): longint; inline $201F {          			move.l	(SP)+,D0	},
   $C09F {           			and.l	(SP)+,D0	}, $2E80 {          			move.l	D0,(SP)		};

function BtOr(X, Y: longint): longint; inline $201F {          			move.l	(SP)+,D0	},
   $809F {           			or.l	(SP)+,D0	}, $2E80 {          			move.l	D0,(SP)		};

function SthiftBts(X: longint; c: integer): longint; inline $321F {          			MOVE.W     (SP)+,D1	},
   $6A08 {          			BPL.S      BPLUS	}, $4441 {          			NEG.W      D1		},
   $201F {          			MOVE.L     (A7)+,D0	}, $E2A8 {          			LSR.L      D1,D0	},
   $6004 {          			BRA.S      EXXX		}, $201F {          	BPLUS:	MOVE.L     (A7)+,D0	},
   $E3A8 {          			LSL.L      D1,D0	}, $2E80 {          	EXXX:	MOVE.L     D0,(A7)	};

procedure callproc(X: ProcPtr); inline $205F, $4E90;

function BtSL( X: longint; B: integer ): longint;
begin
  BtSL := SthiftBts( X, B );
end;

function BtSR( X: longint; B: integer ): longint;
begin
  BtSR := SthiftBts( X, -B );
end;


procedure macsbug; inline $A9FF;
{   $L CRC.Rel }

procedure CMPCRC(V: integer; var c: integer);
 external;

procedure DoCRC(V: integer);
   
   begin { DoCRC}
      CMPCRC(V, CRC);
   end {DoCRC};





   
   procedure di( S: Str255; N: longint);
      
      var
                    T: Str255;
      
      begin
         NumToString(N, T);
         debugstr( concat( S, T ) );
      end;
   
   
   
   

procedure TrimFN(var FName: Str255);
   
   var
                 p: integer;
   
   begin { TrimFN}
      p := pos(':', FName);
      while p > 0 do
         begin
            Delete(FName, 1, p);
            p := pos(':', FName);
         end;
   end {TrimFN};


procedure LoseLast( var D: Str255 );
var p: integer;
begin
   p := length( D );
   while ( p > 1 ) and ( D[ p ] <> ':' ) do
      p := p - 1;
D := copy( D, 1, p );
end;




procedure CloseEm;
   
   begin { CloseEm}
      CloseIn;
      CloseOut;
   end {CloseEm};





procedure RDH  (INPRC: PRocPtr; var ErrCode: Str255; var EPath: Str255);
   
   var
               Typ,
               Cre: osType;
               DFL,
               RFL: longint;
              Good: boolean;
             FName,
            OFName: Str255;
           Version,
               Flg: integer;
   
   
   
   
   
   procedure Error(N: longint; S: Str255);
      
      var
                    T: Str255;
      
      begin { Error}
         NumToString(N, T);
         ErrCode := concat('Error: ', T, ':', S);
         Exit(RDH);
      end {Error};
   
   
   
   
   
   procedure SetF;
      
      var
                   FF: FInfo;
      
      begin { SetF}
         with FF do
            begin
               fdType := Typ;
               fdCreator := Cre;
               fdFlags := BAnd(Flg, $F800);
               with fdLocation do
                  begin
                     h := 0;
                     v := 0;
                  end;
               fdFldr := 0;
            end;
         Err := SetFInfo(ofname, 0, FF);
      end {SetF};
   
   
   
   
   
   procedure xGetChar(var c: char);
      
      begin { xGetChar}
         CallProc(INPRC);
         c := GLOBIN;
      end {xGetChar};
   
   
   
   
   
   procedure SkipLeading;
      
      var
                    c: Char;
      
      begin { SkipLeading}
         repeat
            xGetChar(c);
         until (c = ':') or NetworkEOF;
      end {SkipLeading};
   
   
   
   
   
   procedure GLO(var c: char);
      
      var
                    T: char;
                Bits6: integer;
      
      begin { GLO}
         while InBits < 8 do
            begin
               repeat
                  CallProc(INPRC);
                  if NetworkEOF then
                     begin
{Err := -99;}
                        GLOBIN := '!';
                     end;
                  Bits6 := EncRVec[ Ord(GLOBIN) ];
               until Bits6 < 64;
               InW := BOr(BSL(InW, 6), Bits6);
               InBits := InBits + 6;
            end;
         c := Chr(BAnd(BSR(InW, InBits - 8), $FF));
         {writeln('got lo:', ord(c):5);}
         InBits := InBits - 8;
      end {GLO};
   
   
   
   
   
   procedure GetLoChar(var c: char);
      
      var
                   CC,
                   LC: char;
      
      begin { GetLoChar}
         if RepCount > 0
         then
            begin
               RepCount := RepCount - 1;
               c := LastChar;
            end
         else
            begin
               GLO(c);
               if c = Chr(EscapeChar) then
                  begin 
                     LC := LastChar;
                     GLO(CC);
                     RepCount := Ord(CC);
                     if RepCount = 0
                     then
                     begin
                        c := Chr(EscapeChar);
                        {writeln('got escaped escape');}
                        end
                     else
                        begin
                           RepCount := Ord(CC) -2;
                           {writeln('got repeat count = ',
						   RepCount, ' for char  = ', ord(lc):5);}
                           c := LC;
                        end;
                  end;
               LastChar := c;
            end;
         DoCRC(ord(c)); 
		 {writeln('got actual byte::::', ord(c):4);}
      end {GetLoChar};
   
   
   
   
   
   procedure GetB(var B: integer);
      
      var
                    c: char;
      
      begin { GetB}
         GetLoChar(c);
         B := Ord(c);        
		 {writeln('Got char = ', B:10 );}

      end {GetB};
   
   
   
   
   
   procedure GetW(var B: integer);
      
      var
                   b1,
                   b2: integer;
      
      begin { GetW}
         GetB(b1);
         GetB(b2);
         B := BOr(BSL(b1, 8), b2);
         {writeln('Got word = ', B:10 );}
      end {GetW};
   
   
   
   
   
   procedure GetL(var B: longint);
      
      var
                   b1,
                   b2: integer;
                  lb2,
                 mask: longint;
      
      begin { GetL}
         GetW(b2);
         GetW(b1);
         mask := $10000;
         mask := mask - 1;
         LB2 := BAnd(b2, mask);
         B := BOr(BSL(lb2, 16), b1);
         {writeln('got long = ', B:10);}
      end {GetL};
   
   
   
   
   
   procedure GetT(var B: OsType);
      
      var
                    i: integer;
                    W: integer;
      
      begin { GetT}
         for i := 1 to 4 do
            begin
               GetB(W);
               B[ i ] := Chr(W);
            end;
      end {GetT};
   
   
   
   
   
   procedure GetS(var S: Str255);
      
      var
                    i,
                    L: integer;
                    c: Char;
                
      
      begin { GetS}
         S := '';
         GetB(L);
       
         if (L <= 0) or (L > 128) then Error(0, 'Bad Filen Name Length' );
         for i := 1 to L do
            begin
               GetLoChar(c);
               S := concat(S, c);
            end;
      end {GetS};
   
   
   
   
   
   procedure GetFn;
      
      
      
      
      
      procedure GetOut;
         
         var
                 TopLeft: Point;
              FileFilter: SFTypeList;
                  OReply: SFReply;
         
         begin { GetOut}
            topLeft.h := -1;
            topLeft.v := -1;
            SFPutFile(topLeft, 'Output File?', fname, NIL, OReply);
         end {GetOut};
      
      
      
      
      
      
      begin { GetFn}
         GetS(FName);
         if NetworkEOF
         then
            Error(0, 'No Colon found')
         else
            begin
           { writeln('Fname = "', FName, '"' );}
               TrimFN(FName);
               FName := concat(EPath, ':', FName);
            end;
         Good := true;
      end {GetFn};
   
   
   
   
   
   procedure GetFork(len: longint);
      
      var
                    i: longint;
                    F: char;
                 CRC2: integer;
      
      begin { GetFork}
         CRC := 0;
		 {di('Getting fork length = ', len );}
         for i := 1 to len do
            begin
               GetLoChar(F);
               if Err <> NoErr then
                  Error(1, 'Premature EOF');
               PutChar(F);
            end;
         GetW(CRC2);
         if CRC = 0
         then
{writeln('CRC OKAY!!!!!!!!!!')   }
         else
{writeln('CRC mismatch, computed: ', CRC: 10, '  crc in file:', CRC2:10)};
{di('before call closeout in getfork...', 0 );}
         CloseOut;
		 {di('after call closeout in getfork...', 0 );}
      end {GetFork};
   
   
   
   
   
   procedure MkDir(DN: Str255);
      
      var
                   PB: HParamBlockRec;
                  Vol: integer;
                   WD: longint;
				   Parent: Str255;
				   
      WP: WDPBRec;
	  
      begin { MkDir}
	  Parent := DN;
	  LoseLast( Parent );
	  with WP do
	  begin
	     IoCompletion := NIL;
		 ioNamePtr := StringPtr( @Parent );
		 ioVRefNum := 0;
		 ioWDProcID := 0;
		 ioWDDirID := 0;
	  end;
	  Err := PBOpenWD( WDPBPtr(@WP), false );
	  if Err = NoErr then
	  begin
         with PB do
            begin
               ioCompletion := NIL;
               ioNamePtr := NIL;
			   {
               Err := PBHGetVol(WDPBPtr(@ PB), false);
               if Err = NoErr then
			   }
                  begin
                     Vol := WP.ioVRefNum;
                     with PB do
                        begin
                           ioCompletion := NIL;
						   TrimFn( DN );
                           ioNamePtr := StringPtr(@ DN);
                           ioVRefNum := Vol;
                           ioDirID := 0;
                        end;
                     Err := PBDirCreate(HParmBlkPtr(@ PB), false);
                  end;
            end;
			end;
      end {MkDir};
   
   
   
   
   
   procedure Reader;
      
      var
                 CRC2,
               Suffix: integer;
                    T: Str255;
                   Ex: boolean;
      
      
      
      
      
      procedure GetPrefix;
         
         begin { GetPrefix}
            GetB(Version);
            GetT(Typ);
            GetT(Cre);
            GetW(Flg);
			GetL(DFL);
            GetL(RFL);  

 {writeln('version = ', version, chr(version));
writeln('Creator = ', Cre, ' Type = ', Typ, ' flags = ', Flg:6);
 writeln('data fork size = ', DFL, '  rsrc fork size = ', RFL);}
  end {GetPrefix};
      
      
      
      
      
      procedure GetBody;
         
         
         
         procedure MakeOut;
			  		 procedure MakeDefaultDir;
         var
    Config: SysEnvRec;
	Pa: Str255;
   p: integer;
   
                  procedure dsi(s: Str255; v: longint);
                  
                  var
                                t: str255;
                  
                  begin { dsi}
                     numtostring(V, T);
                     debugstr(concat(S, T));
                  end {dsi};
               

   
               procedure GetPath(InVol, WD: longint; var Path: Str255);
                  
                  var
                          VolName,
                                V: Str255;
                             VRef: integer;
                               DI: longint;
                                P: CInfoPBRec;
                  
                  begin { getpath} 
                     Path := '';
                     repeat
                        with P do
                           begin
                              ioNamePtr := StringPtr(@ V);
                              ioVRefNum := inVol;
                              ioFDirIndex := -1;
                              ioDrDirID := WD;
                           end;
                        Err := PBGetCatInfo(CInfoPBPtr(@ P), false);
						
                        with P do
                           begin
                              WD := ioDrParID;
                              Path := concat(ionameptr ^, ':', Path);
                           end;
                     until (WD = 1) or (err <> noErr);
                  end {GetPath};
               


   begin 
      Err := SysEnvirons( 1, Config );
	  if Err = NoErr then
	  begin
         GetPath( Config.SysVRefNum, 0, Pa );
		 p := Pos( ':', Pa );
		 if p > 0 then
		   Pa := copy( Pa, 1, p );
		 Pa := concat( Pa, 'Incoming' );
		 MkDir( Pa );
		 Err := NoErr;
		 EPath := Pa;
		 TrimFn( OfName );
		 OfName := concat( Pa, ':', OfName );
	  end;
  end;
         
 
            begin { MakeOut}
               Suffix := 0;
               ofname := fname;
               repeat
                  Ex := Exists(0, ofname);
                  if Ex then
                     begin
                        Suffix := Suffix + 1;
                        NumToString(Suffix, T);
                        ofname := concat(fname, '.', T);
                     end;
               until not Ex;
               MakeFile(0, ofname, Cre, Typ);
               Err := FileError;
               if Err <> NoErr then
                  begin
                     {if Err = dirNFErr
                     then}
                        begin
                           MkDir(EPath);
						   if Err <> NoErr then
						     MakeDefaultDir;
                           if Err <> NoErr then
                              Error(Err, concat( 'Making directory "',
							  EPath, '"' ) );
                           MakeFile(0, ofname, Cre, Typ);
                           Err := FileError;
                        end;
end;
if Err <> NoErr then
Error(Err, concat( 'Opening output file ', OFName ) );
            end {MakeOut};
         
         
         
         
         
         procedure Get2Forks;
            
            var
                       CRCR: integer;
            
            begin { Get2Forks}
               OpenOut(0, ofname);
               Err := FileError;
               if Err = NoErr
               then
                  begin
				  {di('before get data fork...', 0 );}
                     GetFork(DFL);
					 {di('after get data fork...', 0 );}
                     if RFL > 0
                     then
                        begin 
						{di('before get rsrc fork...', 0 );}
                           OpenOutRsrc(0, ofname);
                           Err := FileError;
                           if Err = NoErr
                           then
                              GetFork(RFL)
                           else
                              Err := NoErr;
                        end
                     else
                        GetW(CRCR);
						{di('after get rsrc fork...', 0 );}
                  end
               else
                  Error(Err, 'Open output file error');
            end {Get2Forks};
         
         
         
         
         
         
         begin { GetBody}
            GetW(CRC2);
            if CRC = 0
            then
               
            else
               ;
            MakeOut;
            if Err = NoErr
            then
               Get2Forks
            else
               Error(FileError, 'Can''t create output file');
         end {GetBody};
      
      
      
      
      
      
      begin { Reader}
         GetPrefix;
         if (RFL >= 0) and (DFL >= 0)
         then
            GetBody
         else
            Error(0, 'Bad fork size');
      end {Reader};
   
   
   
   
   
   procedure Finale;
      
      var
                 xofname: Str255;
      
      
      
      
      
      procedure GetPath(var Path: Str255);
         
         var
                 VolName,
                       V: Str255;
                    VRef,
                     Err: integer;
                      DI,
                      WD: longint;
                       P: CInfoPBRec;
                      PB: WDPBRec;
         
         begin { getpath}
            Path := '';
            PB.ioNamePtr := StringPtr(@ V);
            Err := PBHGetVol(WDPBPtr(@ PB), false);
            WD := PB.iowddirid;
            repeat
               with P do
                  begin
                     ioNamePtr := StringPtr(@ V);
                     ioVRefNum := PB.ioVRefNum;
                     ioFDirIndex := -1;
                     ioDrDirID := WD;
                  end;
               Err := PBGetCatInfo(CInfoPBPtr(@ P), false);
               with P do
                  begin
                     WD := ioDrParID;
                     Path := concat(ionameptr ^, ':', Path);
                  end;
            until (WD = 1) or (err <> noErr);
            if Err <> NoErr then
               Path := '???';
         end {GetPath};
      
      
      
      
      
      
      begin { Finale}
         TrimFN(fname);
		 xofname := fname;
         TrimFn(xofname);
         {GetPath(Path);}
         if Err = NoErr then
            if fname = xofname
            then
               ErrCode := concat(' File "', ofname, '" received.')
            else
               ErrCode := concat(' File "', fname, '" received as "', ofname, '"');
      end {Finale};
   
   
   
   
   
   
   begin { RDH}
      InBits := 0;
      InW := 0;
      SkipLeading;
      if NetworkEOF
      then
         Error(0, 'Didn''t see initial colon  ":"')
      else
         begin
            CRC := 0;
            GetFn;
            if Good then
               begin
                  Reader;
                  if Err = NoErr then
                     begin
                        SkipLeading;
                        CloseEm;
                        if Err = NoErr then
                           SetF;
                     end;
               end;
         end;
      Finale;
   end {RDH};





procedure BinToHex {(iv: integer; ifn: Str255; OutProc: ProcPtr)};
   
   const
      MaxWidth = 64;
   
   
procedure Check(Msg: Str255);
   
   


procedure Error(N: longint; S: Str255);
   
   var
                 T: Str255;
   
   begin { Error}
      NumToString(N, T);
	  exit( BinToHex );
	  {
      debugstr(concat('BINHEX Error #', T, ' ', S));
	  }
   end {Error};



   begin { Check}
      if Err = NoErr
      then
         begin
            if debug then
               debugstr(concat(Msg, ' OK'));
         end
      else
         Error(Err, Msg);
   end {Check};



   
   procedure DoJob;
      
      var
                   FI: ParamBlockRec;
                  ffn: Str255;
				  iii: integer;
      
      
      
      
      
      procedure FlushLine;
         
         begin { FlushLine}
            OutLn[ 0 ] := Chr(Outcc);
            CallProc(OutProc);
            Outcc := 0;
         end {FlushLine};
      
      
      
      
      
      procedure PutChar(c: char);
         
         begin { PutChar}
            if Outcc < 255 then
               begin
                  Outcc := Outcc + 1;
                  OutLn[ Outcc ] := c;
               end;
            if Outcc >= MaxWidth then
               FlushLine;
         end {PutChar};
      
      
      
      
      
      procedure PutB(c: integer);
         
         var
                       i: integer;
         
         
         
         
         
         procedure PutLoB(c: integer);
            
            begin { PutLoB} 
			{writeln('plo:', c:4);}
               OBits := OBits + 8;
               OutW := BOR(BSL(OutW, 8), BAND(c, $FF));
               while OBits >= 6 do
                  begin
                     PutChar(EncVec[ BAnd(BSR(OutW, OBits - 6), $3F) +1 ]);
                     OBits := OBits - 6;
                  end;
            end {PutLoB};
         
         
         
         
         
         procedure FlushRept;
            
            begin { FlushRept}
               PutLoB(EscapeChar);
               PutLoB(Rep+1);
               Rep := 0;
               LastC := -1;
            end {FlushRept};
         
         
         procedure PutHB( C: integer );
		 begin
		    PutLoB( C );
		    if c = EscapeChar then
               PutLoB(0);
            end;
         
         
         
         begin { PutB}
            c := BAnd(ord(c), $FF);
            { writeln('Putting byte ', c );}
            CMPCRC(c, CRC);
            if c = LastC
            then
               begin
                  Rep := Rep + 1;
                  if Rep >= 254 then
                     FlushRept;
               end
            else
               begin { new char }
                  if Rep > 0 then
                     begin
                        if Rep >= 2
                        then
                           FlushRept
                        else
                           for i := 1 to Rep do
                              PutHB(LastC);
                        Rep := 0;
                     end;
                  PutHB(c);
                  LastC := c;
               end;
         end {PutB};
      
      
      
      
      
      procedure PutW(W: integer);
         
         begin { PutW}
            PutB(BSR(W, 8));
            PutB(W);
         end {PutW};
      
      
      
      
      
      procedure PutL(L: longint);
         
         begin { PutL}
         {writeln('PutL ', L:15 );}
            PutW(BSR(L, 16));
            PutW(L);
         end {PutL};
      
      
      
      
      
      procedure PutCRC;
         
         begin { PutCRC}
            DoCRC(0);
            DoCRC(0);
            PutW(CRC);
            CRC := 0;
         end {PutCRC};
      
   
      
      
      
      procedure Put4(S: OsType);
         
         var
                       i: integer;
         
         begin { Put4}
            for i := 1 to 4 do
               PutB(Ord(S[ i ]));
         end {Put4};
      
      
      
      
      
      procedure CopyFork;
         
         var
                       i: longint;
                      Ch: char;
         
         
         
         
         
         procedure PutLen;
            
            var
                        Len: longint;
            
            begin { PutLen}
               Err := GetEOF(InRef, Len);
               Check('Getting EOF');
               PutL(Len);
            end {PutLen};
         
         
         
         
         
         
         begin { CopyFork}
            CRC := 0;
            GetChar(Ch);
            while not FileEOF do
               begin
                  PutB(Ord(Ch));
                  GetChar(Ch);
               end;
         end {CopyFork};
      
      
      
      
      
      procedure PutBX(P: UnivPtr; Len: longint);
         
         type
                     CA = packed array [ 1..1 ] of char;
                CharPtr = ^CA;
         
         var
                       i: integer;
         
         begin { PutBX}
            for i := 1 to Len do
               PutB(Ord(CharPtr(P) ^ [ i ]));
         end {PutBX};
      
      
      
      
      
      procedure PutFI;
         
         begin { PutFI}
            PutB(0);
            with FI, ioFlFndrInfo do
               begin
                  Put4(Fdtype);
                  Put4(fdCreator);
                  PutW(BAnd(FdFlags, $F800));
                  PutL(Fi.ioFlLgLen);
                  PutL(Fi.ioFlRLgLen);
               end;
            PutCRC;
         end {PutFI};
      
      
      
      
      
      procedure PutS(S: str255);
         
         var
                       i: integer;
         
         begin { PutS}
            for i := 1 to Length(S) do
               PutChar(S[ i ]);
            FlushLine;
         end {PutS};
      
      
      
      
      
      procedure InitVars;
         
         begin { InitVars}
            RepCount := 0;
            Outcc := 0;
            Rep := 0;
            PutS('');
            PutS('(This file must be converted with BinHex 4.0 or POPmail 1.5)');
            PutS('');
            PutChar(':');
            CRC := 0;
            OBits := 0;
            OutW := 0;
            LastC := -1;
            ffn := ifn;
            TrimFN(ffn);
         end {InitVars};
      
      
      
      
      
      
      begin { DoJob}
         InitVars;
         PutBX(@ ffn, Length(ffn) +1);
         with FI do
            begin
               ioCompletion := NIL;
               ioNamePtr := @ ifn;
               iovRefNum := iv;
               iofVersNum := 0;
               iofDirIndex := 0;
            end;
         Err := PBGetFInfo(@ FI, false);
         Check('Getting file info');
         if Err = NoErr then
            begin
               PutFI;
               CopyFork;
               PutCRC;
               CloseIn;
               Check('Closing data fork');
               CRC := 0;
               if Fi.ioFlRLgLen > 0 then
                  begin
                     OpenInRsrc(iv, ifn);
                     Err := FileError;
					 Check( 'Opening Resource fork');
                     CopyFork;
                  end;
               PutCRC;
               {if OBits > 0 then}
			   for iii := 1 to 4 do
                  PutB(LastC + 1);
               PutChar(':');
               PutS('');
            end;
      end {DoJob};
   
   
   
   
   
   
   begin { BinToHex}
      OpenIn(iv, ifn);
      if FileError = NoErr then
         begin
            DoJob;
            CloseIn;
         end;
   end {BinToHex};





procedure InitBinHex;
   
   var
                 I: integer;
                 c: Char;
   
   begin { Init}
      EncVec :=
         '!"#$%&''()*+,-012345689@ABCDEFGHIJKLMNPQRSTUVXYZ[`abcdefhijklmpqr';
      for I := 0 to 255 do
         EncRVec[ I ] := 100;
      for I := 1 to length(EncVec) do
         begin
            c := EncVec[ I ];
            EncRVec[ Ord(c) ] := I - 1;
         end;
   end {InitBinHex};





end.
