program testrun;
uses memtypes, quickdraw, osintf, toolintf, packintf;

var thedoc, theapp: str255;

      
   
   procedure Run(Doc: Str255; var ErrorCode: Str255);
      
      const
              DeskFn = 'Desktop';
      
      var
                  Err, Res: integer;
              Running: boolean;
                 FCre,
                 FTyp: OsType;
      
      
      
      
      
      procedure Assert(E: integer; Msg: Str255);
         
         var
                      ES: Str255;
         
         begin { Signal}
            if E <> NoErr then
               begin
                  NumToString(E, ES);
                  case E of
                     fnferr:
                        Msg := 'File not Found';
                  end;
                  ErrorCode := concat('Error #', ES, ': ', Msg);
                  Exit(Run);
				   {writeln(ErrorCode );
                  readln;
                  halt;}
               end;
         end {Assert};
      
      
      
      
      
      procedure CheckRes(Msg: Str255);
         
         begin { CheckRes}
            Err := ResError;
            if Err <> NoErr then
               Assert(Err, concat('Resource error:', Msg));
         end {CheckRes};
      
      
      
            procedure CheckLRes(Msg: Str255);
               
               begin { CheckLRes}
                  Err := ResError;
                  if Err <> NoErr then
                     begin
                        CloseResFile(Res);
                        Assert(Err, Msg);
                     end;
               end {CheckLRes};
            
            
            
         
      
      procedure RunX(DeskVol: integer);
 
         var
                 AppName: Str255;
                  AppDir: longint;
                     Ref: integer;
                       H: Handle;
                     Len: longint;
                    Done: boolean;
                  
           

      
            
            procedure GetBody;
               
                                  const
                  FileRefs = 'FREF';
            
            type
                      Frec = record
                                      FType: OsType;
                                        RID: integer;
                            end;
               
                      FPtr = ^FRec;
                   FHandle = ^FPtr;
                   BunType = record
                                  Signature: OsType;
                                     VersId: integer;
                                       RTyp: integer;
                                     RTList: integer;
                            end;
               
                   ResPair = record
                                    LocalID: integer;
                                   ActResID: integer;
                            end;
               
                    ResArr = array [ 1..1 ] of ResPair;
                   ResType = record
                                       ResN: OsType;
                                     ResCnt: integer;
                                    ResList: ResArr;
                            end;
               
                   ResTPtr = ^ResType;
                    BunPtr = ^BunType;

               var
                                     ResId: integer;
                     Actual: integer;
            
 
               
               
               procedure ScanFRef;
                  
                  var
                               FC,
                                i: integer;
                                H: FHandle;
                                
                                
            
            
            function Ots(S: OsType): str255;
               
               var
                             i: integer;
               
               begin { Ots}
                  Ots := 'XXXX';
                  for i := 1 to 4 do
                     Ots[ i ] := S[ i ];
               end {Ots};
            
            
           procedure DoIt; var PA: Str255;
		                  
               
               

		                  
               
               procedure GetPath(InVol, WD: longint; var Path: Str255);
                  
                  var
                          VolName,
                                V: Str255;
                             VRef,
                              Err: integer;
                               DI: longint;
                                P: CInfoPBRec;
                  
                  begin { getpath} {dsi('invol = ', invol );
		 dsi('wd = ', wd );}
                     Path := '';
                     repeat
                        with P do
                           begin
                              ioNamePtr := StringPtr(@ V);
                              ioVRefNum := inVol;
                              ioFDirIndex := -1;
                              ioDrDirID := WD;
                           end;
                        Err := PBGetCatInfo(CInfoPBPtr(@ P), false);
                        with P do
                           begin
                              WD := ioDrParID;
                              Path := concat(ionameptr ^, ':', Path);
                           end;
                     until (WD = 1) or (err <> noErr);
                     
                  end {GetPath};
               

		   begin
		      GetPath( DeskVol, AppDir, PA );
			  ErrorCode := concat( Pa, AppName );
		   end;
         
            
                  
                  begin { ScanFRef}
                  {writeln('scanning FREF');}
                     FC := Count1Resources(FileRefs);
                     ResId := -9999;
                     i := 1; Running := false;
                     while (not Running) and (i <= FC) do
                        begin
                           H := FHandle(Get1IndResource(FileRefs, i));
                           CheckRes('Get FREF resource');
                           if H <> NIL then
                              begin
                                 HLock(Handle(H));
                                 {writeln('comparing types ', Ots(H^^.ftype), ' and ', Ots(FTyp) );}
                                 if H ^^.FType = FTyp then
                                    begin
                                       ResID := H ^^.RID;
                                       i := 9999;                              Running := true;
                                       Doit;
                                    end;
                                 HUnLock(Handle(H));
                                 ReleaseResource(Handle(H));
                                 i := i + 1;
                              end;
                        end;
                     if ResID = -9999
                     then
                        {writeln( 'Can''t find matching FREF')}
                     else
                       {writeln('Got resid = ', resid );};
                  end {ScanFRef};
               
               
               
              
               begin { GetBody}
                  ScanFref;
                  CloseResFile(Res);
               end {GetBody};
            
            
            
         
         
         
         
         procedure Scan;
            
            const
               MaxScanTime = 900 { 15 sec };
            
            type
                       Rec = record
                                       Icon: OsType;
                                        Dir: longint;
                                       Appl: Str255;
                            end;
               
                      RPtr = ^Rec;
            
            var
                          P: RPtr;
                         LA: integer;
                  StartTime: longint;
            
            begin { Scan}
               P := RPtr(H ^);
               Done := false;
               StartTime := TickCount;
               repeat
                  with P ^ do
                     begin
                        {writeln('ICON="', Icon, '"   Dir = ', Dir: 9, '  Appl = "', Appl, '"');}
                        if Icon = FCre
                        then
                           
                              Done := true
                           
                        else
                           begin
                              LA := Length(Appl) +1 + 8;
                              if Odd(LA) then
                                 LA := LA + 1;
                              P := RPtr(Ord4(P) +LA);
                              Len := Len - LA;
                           end;
                     end;
               until Done or (Len < 0) or (TickCount > StartTime + MaxScanTime);
               if Done
               then
                  begin
                     AppName := P ^.Appl;
                     AppDir := P ^.Dir;
                  end
               else
                  begin
                     AppName := '???';
                     AppDir := -1;
                  end;
            end {Scan};
         
         
         
         
         
         function GoToVol(Vol, Dir: longint): longint;
            
            var
                         PB: WDPBRec;
            
            begin { GoToVol}
               with PB do
                  begin
                     ioNamePtr := NIL;
                     ioVRefNum := Vol;
                     ioWDProcID := 0;
                     ioWDDirID := Dir;
                  end;
               Err := PBOpenWD(WDPBPtr(@ PB), false);
               Assert(Err, 'OpenWD');
               GoToVol := PB.iovrefnum;
            end {GoToVol};
         
         
         
         
            
            
            
            
         
         procedure GetIC;
            
                
            
            
            
            
            begin { GetIC}
               Res := OpenRFPerm(AppName, GoToVol(DeskVol, AppDir), fsRdPerm);
               if Res = -1
               then
                  CheckLRes('OpenResFilePerm')
               else
                  GetBody;
            end {GetIC};
         
         
         
         
         
         
         begin { RunX}
            SetResLoad(false);
            Ref := OpenRFPerm(DeskFn, DeskVol, fsRdPerm);
            SetResLoad(true);
            if Ref = -1
            then
               begin
                  Err := ResError;
                  Assert(Err, 'OpenRF');
               end
            else
               begin
                  H := Get1Resource('APPL', 0);
                  if H = NIL
                  then
                     begin
                        Assert(-99, 'GetResource error');
                        CloseResFile(Ref);
                     end
                  else
                     begin
                        HLock(H);
                        Len := GetHandleSize(H);
                        Scan;
                        HUnLock(H);
                        DisposHandle(H);
                        CloseResFile(Ref);
                        if Done then
                              GetIC;
                     end;
               end;
         end {RunX};
      
      
      
      
      
      procedure GFI;
         
         var
                      FI: FInfo;
         
         begin { GFI}
         {writeln('Getting info for "', Doc, '"' );}
            Err := GetFInfo(Doc, 0, FI);
            if Err = NoErr then
               with FI do
                  begin
                     FCre := fdCreator;
                     FTyp := FdType;
                  end;
         end {GFI};
      
      
      
      
      
      procedure ScanVols;
         
         var
                     Drv: integer;
                      PB: ParamBlockRec;
                 VolName: Str255;
         
         begin { ScanVols}
            Drv := 1;
            Running := false;
            repeat
               with PB do
                  begin
                     ioNamePtr := StringPtr(@ VolName);
                     ioVRefNum := 0;
                     ioVolIndex := Drv;
                  end;
               Err := PBGetVInfo(ParmBlkPtr(@ PB), false);
               if Err <> -35 then
                  begin
                     Assert(Err, 'GetVInfo');
{writeln;
                     writeln('******* Scanning volume ', VolName );}
                     RunX(PB.ioVRefNum);
                     Drv := Drv + 1;
                  end;
            until Running or (Err <> NoErr);
         end {ScanVols};
      
      
      
      
      
      
      var
                  UID: integer;
                IName: Str255;
                    i,
                  TID: integer;
                  TTY: ResType;
                  TNa: Str255;
      
      
      begin { Run}
         ErrorCode := '';
         GFI;
         Assert(Err, 'GetFileInfo');
         if FTyp = 'APPL'
         then
            ErrorCode := '-'
         else
         if FTyp = 'STAK'
         then
            ErrorCode := '@'
         else
		 begin
            ScanVols;
         if not Running then
            ErrorCode := 'Can''t find the application.';
			end;
      end {Run};
   
   
   
begin thedoc := 'grg2:incoming:spread';
       write('Doc:');
       writeln(thedoc);
       Run( thedoc, theapp);
       writeln('Theapp = ', theapp );
   readln;
   end.
   