
{$R-}
{$Z+}
{$S PrintField }
unit DummyUnit;

interface
uses
       MemTypes,
      quickDraw,
         OsIntf,
       ToolIntf,
       Packintf,
       macprint,
      HyperXCmd;





implementATION





procedure Main(paramPtr: XCmdPtr); forward;

procedure ENTRYPOINT(paramPtr: XCmdPtr);
   
   begin { ENTRYPOINT}
      Main(paramPtr);
   end {ENTRYPOINT};
{----------------------------------------------------------------}






const
       idledlg = 9140;
 marginDefault = 36;
     throwAway = 5;
   scrollWidth = 18;
     wideExtra = 4;





procedure myStdRect(verb: GrafVerb; r: rect);
{ This procedure will replace the StdRect QuickDraw bottleneck procedure }
{ when we go into our printing loop.  We use TEUpdate to draw text, and }
{ TEUpdate calls EraseRect to clear the way before it draws anything. }
{ On a blank sheet of paper, there's no need to erase, so we replace the }
{ QuickDraw bottleneck that handles rectangles with a "do-nothing" procedure. }
{ This has two advantages when printing on the LaserWriter:  }
{    1) Printing becomes faster, and  }
{    2) A problem is avoided--the rectangles erased sometimes included the }
{ descenders of lines of text already drawn.  This happened with PrintField 1.0, }
{ which produced lines of text that were cut off at the bottom when the lineHeight }
{ of the field was smaller than about 4/3 of the average character height. }
   
   begin { myStdRect}
   end {myStdRect};





function GetScreenBitsBounds: Rect;
   
   var
         phonyPort: GrafPort;
          savePort: GrafPtr;
{ This procedure tells us screenbits.bounds, which we can't get }
{ by conventional means, having no access to the QD globals. }
   
   begin { GetScreenBitsBounds}
      GetPort(savePort);
      OpenPort(@ phonyPort);
      GetScreenBitsBounds := phonyPort.portRect;
{ When a port is opened, the initial setting of its portRect }
{ is screenbits.bounds (IM I-163) }
      ClosePort(@ phonyPort);
      SetPort(savePort);
   end {GetScreenBitsBounds};





function GetField(paramPtr: XCmdPtr; whichField: Str255; var theHandle: Handle):
   OSErr;
{ Given a valid designation of a field--by name, id, or number, }
{ returns the text of the field in a handle. }
{ We go through all of this to make sure we're printing the contents of }
{ a real field, and not just of an ordinary container, because later we'll }
{ be using field properties--lineHeight and so on--in order to format our output. }
   
   var
         theString: Str255;
     cardFieldFlag: BOOLEAN;
          matchPtr: Ptr;
         theResult: Handle;
           fieldID: INTEGER;
   
   begin { GetField}
      theResult := EvalExpr(paramPtr, CONCAT('the long name of ', whichField));
{ if HC can get the long name of the object designated by whichField, it's a valid object }
      if (theResult <> NIL) and (paramPtr ^.result = noErr)
      then
         begin
            MoveHHi(theResult);
            HLock(theResult);
            matchPtr := StringMatch(paramPtr, 'field', theResult ^);
{ if the long name of the object contains the word "field," then it's a field }
            if matchPtr <> NIL
            then
               begin
                  matchPtr := StringMatch(paramPtr, 'card field', theResult ^);
{ we want to know if it's a card or background field in order }
{ to set the cardFieldFlag for GetFieldbyID, below }
                  cardFieldFlag := (matchPtr <> NIL);
                  HUnlock(theResult);
                  DisposHandle(theResult);
                  theResult := EvalExpr(paramPtr, CONCAT('the id of ',
                     whichField));
{ we get the id of the field so that we can call GetFieldbyID }
{ Could use EvalExpr at this point, because we already know it's a field.}
                  if (theResult <> NIL) and (paramPtr ^.result = noErr) then
                     begin
                        MoveHHi(theResult);
                        HLock(theResult);
                        ZeroToPas(paramPtr, theResult ^, theString);
                        fieldID := StrToNum(paramPtr, theString);
                        HUnlock(theResult);
                        DisposHandle(theResult);
                        theResult := GetFieldByID(paramPtr, cardFieldFlag,
                           fieldID); { get the text }
                     end; { if theResult <> nil when asking for the id of the field }
               end { if "field" is part of the long name of the object }
            else
               begin
                  HUnlock(theResult);
                  DisposHandle(theResult);
                  theResult := NIL;
               end;
         end; { if theResult <> nil when asking for the long name of the object }
      theHandle := theResult;
      GetField := paramPtr ^.result;
   end {GetField}; { function GetField }





function NTS(V: longint): Str255;
   
   var
                 T: Str255;
   
   begin { NTS}
      NumToString(V, T);
      NTS := T;
   end {NTS};





function GetRectOfField(paramPtr: XCmdPtr; whichField: Str255): Rect;
   
   var
           theRect: rect;
   
   
   
   
   
   function GetRectItem(theItem: INTEGER): INTEGER;
      
      var
            theResult: Handle;
          rectItemStr: Str255;
      
      begin { GetRectItem}
         theResult := EvalExpr(paramPtr, CONCAT('item ', NTS(theItem),
            ' of the rect of ', whichField));
         if theResult <> NIL
         then
            begin
               ZeroToPas(paramPtr, theResult ^, rectItemStr);
               DisposHandle(theResult);
               GetRectItem := StrToNum(paramPtr, rectItemStr);
            end
         else
            GetRectItem := 0;
      end {GetRectItem};
   
   
   
   
   
   
   begin { GetRectOfField}
      theRect.left := GetRectItem(1);
      theRect.top := GetRectItem(2);
      theRect.right := GetRectItem(3);
      theRect.bottom := GetRectItem(4);
      GetRectOfField := theRect;
   end {GetRectOfField};





function GetJustOfField(paramPtr: XCmdPtr; whichField: Str255): INTEGER;
   
   var
         theResult: Handle;
         textAlign: INTEGER;
            theStr: Str255;
   
   begin { GetJustOfField}
      theResult := EvalExpr(paramPtr, CONCAT('the textAlign of ', whichField));
      ZeroToPas(paramPtr, theResult ^, theStr);
      DisposHandle(theResult);
      if theStr = 'left'
      then
         textAlign := teJustLeft
      else
         if theStr = 'center'
         then
            textAlign := teJustCenter
         else
            if theStr = 'right'
            then
               textAlign := teJustRight
            else
               textAlign := teJustLeft;
      GetJustOfField := textAlign;
   end {GetJustOfField};





function GetFontOfField(paramPtr: XCmdPtr; whichField: Str255): INTEGER;
   
   var
         theResult: Handle;
        fontNumber: INTEGER;
          fontName: Str255;
   
   begin { GetFontOfField}
      theResult := EvalExpr(paramPtr, CONCAT('the textFont of ', whichField));
      ZeroToPas(paramPtr, theResult ^, fontName);
      DisposHandle(theResult);
      GetFNum(fontName, fontNumber);
      GetFontOfField := fontNumber;
   end {GetFontOfField};





function GetTextSizeOfField(paramPtr: XCmdPtr; whichField: Str255): INTEGER;
   
   var
         theResult: Handle;
           theSize: INTEGER;
           sizeStr: Str255;
   
   begin { GetTextSizeOfField}
      theResult := EvalExpr(paramPtr, CONCAT('the textSize of ', whichField));
      ZeroToPas(paramPtr, theResult ^, sizeStr);
      DisposHandle(theResult);
      theSize := StrToNum(paramPtr, sizeStr);
      GetTextSizeOfField := theSize;
   end {GetTextSizeOfField};





function GetLineHeightOfField(paramPtr: XCmdPtr; whichField: Str255): INTEGER;
   
   var
         theResult: Handle;
     theLineHeight: INTEGER;
         heightStr: Str255;
   
   begin { GetLineHeightOfField}
      theResult := EvalExpr(paramPtr, CONCAT('the textHeight of ', whichField));
      ZeroToPas(paramPtr, theResult ^, heightStr);
      DisposHandle(theResult);
      theLineHeight := StrToNum(paramPtr, heightStr);
      GetLineHeightOfField := theLineHeight;
   end {GetLineHeightOfField};





procedure AdjustTextRect(paramPtr: XCmdPtr; whichField: Str255; var theRect:
   rect);
{ Given the rect of a field, adjusts the rectangle to make it the smallest }
{ rectangle containing the text of the field visible on the screen }
   
   var
         theResult: Handle;
     theLineHeight: INTEGER;
            theStr: Str255;
   
   begin
{ if the field has wide margins, we shrink the rectangle by wideExtra pixels all around }
      theResult := EvalExpr(paramPtr, CONCAT('the wideMargins of ', whichField));
      ZeroToPas(paramPtr, theResult ^, theStr);
      DisposHandle(theResult);
      if theStr = 'true' then
         InsetRect(theRect, wideExtra, 0);
{ if it's a scrolling field, we subtract scrollWidth from the right coordinate of the rect }
      theResult := EvalExpr(paramPtr, CONCAT('the style of ', whichField));
      ZeroToPas(paramPtr, theResult ^, theStr);
      DisposHandle(theResult);
      if theStr = 'scrolling' then
         with theRect do
            right := right - scrollWidth;
   end {AdjustTextRect};





function GetTextStyleOfField(paramPtr: XCmdPtr; whichField: Str255): Style;
   
   var
      theTextStyle: Handle;
            thePtr: Ptr;
          theStyle: Style;
   
   
   
   
   
   function StyleIs(textStyle: handle; aStyle: Str255): BOOLEAN;
      
      var
               thePtr: Ptr;
      
      begin { StyleIs}
         thePtr := StringMatch(paramPtr, aStyle, textStyle ^);
         if thePtr <> NIL
         then
            StyleIs := TRUE
         else
            StyleIs := FALSE;
      end {StyleIs};
   
   
   
   
   
   
   begin { GetTextStyleOfField}
      theStyle := [ ];
      theTextStyle := EvalExpr(paramPtr, CONCAT('the textStyle of ', whichField));
      if theTextStyle <> NIL then
         begin
            if StyleIs(theTextStyle, 'bold') then
               theStyle := theStyle + [ bold ];
            if StyleIs(theTextStyle, 'italic') then
               theStyle := theStyle + [ italic ];
            if StyleIs(theTextStyle, 'underline') then
               theStyle := theStyle + [ underline ];
            if StyleIs(theTextStyle, 'outline') then
               theStyle := theStyle + [ outline ];
            if StyleIs(theTextStyle, 'shadow') then
               theStyle := theStyle + [ shadow ];
            if StyleIs(theTextStyle, 'condense') then
               theStyle := theStyle + [ condense ];
            if StyleIs(theTextStyle, 'extend') then
               theStyle := theStyle + [ extend ];
            DisposHandle(theTextStyle);
         end;
      GetTextStyleOfField := theStyle;
   end {GetTextStyleOfField};





procedure PrintField(paramPtr: XCmdPtr);
   
   var
       currentPort: grafPtr;
          myDlgPtr: DialogPtr;
            myDITL,
            myDLOG: Handle;
            dlogOK,
           goAhead: BOOLEAN;
          prRecHdl: THPrint;
           myStRec: TPrStatus;
          myPrPort: TPPrPort;
           theText: Handle;
               hTE: TEHandle;
            length: longint;
      theTextStyle: Style;
       theTextFont,
       theTextSize,
     theTextHeight,
              just: INTEGER;
          FontIRec: FontInfo;
         fieldName,
               str: Str255;
         fieldRect,
          destRect,
          viewRect: rect;
        fieldWidth,
        pageHeight,
          numLines,
         numCopies,
         myPgCount: INTEGER;
    parameterCount,
        leftMargin,
       rightMargin,
         topMargin,
      bottomMargin: INTEGER;
        ascentDiff: INTEGER;
       dialogCount: LONGINT;
               err: OSErr;
      goToThisCard: Str255;
   
   
   
   
   
   procedure Fail(errMsg: Str255); { set theResult and quit }
      
      begin { Fail}
         paramPtr ^.returnValue := PasToZero(paramPtr, errMsg);
      end {Fail};
   
   
   
   
   
   procedure GetDialog; { check to see if DLOG and DITL are present; }
{ if so, put up the dialog }
      
      begin { GetDialog}
         dlogOK := FALSE;
         myDLOG := GetResource('DLOG', idledlg);
         if myDLOG <> NIL then
            begin
               myDITL := GetResource('DITL', idledlg);
               dlogOK := myDITL <> NIL;
               if dlogOK then
                  myDlgPtr := GetNewDialog(idledlg, NIL, NIL);
            end;
      end {GetDialog};
   
   
   
   
   
   procedure ShowDialog;
{ Here we mess with the appearance of the dialog.  We center it on the screen, }
{ and also center the text items within the dialog. }
{ Also, we grab the document name and make it the window title, so that the }
{ printer driver can access that information -- see Tech Note #72. }
      
      var
       mainScreenRect,
             dlogRect: rect;
              hGlobal: INTEGER;
       theDialogTHndl: DialogTHndl;
             wMgrPort: GrafPtr;
               wTitle: Str255;
            theResult: Handle;
      
      
      
      
      
      procedure CenterTextItem(theDialogPtr: DialogPtr; itemNo: INTEGER);
         
         var
                savePort: grafPtr;
                    item: handle;
                itemType: INTEGER;
                dlogRect,
                 itemBox: Rect;
                  theStr: Str255;
                   width,
                textLeft: INTEGER;
         
         begin { CenterTextItem}
            GetDItem(theDialogPtr, itemNo, itemType, item, itemBox);
            if item <> NIL then
               if (itemType = statText) or (itemType = statText + itemDisable)
               then
                  begin
                     GetPort(savePort);
                     SetPort(theDialogPtr);
                     GetIText(item, theStr);
                     width := StringWidth(theStr) +6;
                     if itemNo = 1
                     then { kludge for getting the width of an item that includes paramText }
                        width := width - StringWidth('^0') +StringWidth(wTitle);
                     dlogRect := theDialogPtr ^.portRect;
                     with dlogRect do
                        textLeft := (right - left - width) div 2;
                     with itemBox do
                        begin
                           left := textLeft;
                           right := textLeft + width;
                        end;
                     SetDItem(theDialogPtr, itemNo, itemType, item, itemBox);
                     SetPort(savePort);
                  end;
         end {CenterTextItem};
      
      
      
      
      
      
      begin { ShowDialog}
         if dlogOK then
            begin
               theResult := EvalExpr(paramPtr, CONCAT('the short name of ',
                  fieldName));
               if theResult <> NIL
               then
                  begin
                     ZeroToPas(paramPtr, theResult ^, wTitle);
                     DisposHandle(theResult);
                  end
               else
                  wTitle := fieldName;
               SetWTitle(myDlgPtr, wTitle);
               ParamText(wTitle, '', '', '');
               CenterTextItem(myDlgPtr, 1);
               CenterTextItem(myDlgPtr, 2);
               myDLOG := GetResource('DLOG', idledlg);
               theDialogTHndl := DialogTHndl(myDLOG);
{ we get the rect of the dialog directly from its DLOG resource in memory }
               dlogRect := theDialogTHndl ^^.boundsRect;
               mainScreenRect := GetScreenBitsBounds;
               with mainScreenRect do
                  hGlobal := right - left;
               with dlogRect do
                  begin
                     hGlobal := (hGlobal - (right - left)) div 2;
                     MoveWindow(myDlgPtr, hGlobal, top, FALSE);
                  end;
               ShowWindow(myDlgPtr);
               BringToFront(myDlgPtr);
               DrawDialog(myDlgPtr);
            end;
      end {ShowDialog};
   
   
   
   
   
   procedure SetDefaults;
      
      begin { SetDefaults}
         viewRect := prRecHdl ^^.prInfo.rPage;
         topMargin := marginDefault;
         bottomMargin := marginDefault;
         leftMargin := marginDefault;
         fieldRect := GetRectOfField(paramPtr, fieldName);
         AdjustTextRect(paramPtr, fieldName, fieldRect);
         with fieldRect do
            fieldWidth := right - left - throwAway;
      end {SetDefaults};
   
   
   
   
   
   procedure GetDialogCount;
      
      begin { GetDialogCount}
         if parameterCount > 1
         then
            begin
               ZeroToPas(paramPtr, paramPtr ^.params[ 2 ] ^, str);
               dialogCount := StrToNum(paramPtr, str);
            end { if parameterCount > 1 }
         else
            dialogCount := 2;
      end {GetDialogCount};
   
   
   
   
   
   procedure GetMarginSettings;
      
      var
            theBottom: INTEGER;
      
      begin { GetMarginSettings}
         if parameterCount > 2 then
            begin
               ZeroToPas(paramPtr, paramPtr ^.params[ 3 ] ^, str);
               leftMargin := StrToNum(paramPtr, str);
               if leftMargin < 0 then
                  leftMargin := marginDefault;
               if parameterCount > 3 then
                  begin
                     ZeroToPas(paramPtr, paramPtr ^.params[ 4 ] ^, str);
                     rightMargin := StrToNum(paramPtr, str);
                     if rightMargin >= 0 then
                        begin
                           with viewRect do
                              fieldWidth := right - left - leftMargin -
                                 rightMargin;
                           if fieldWidth < 10 then
                              fieldWidth := 10;
                        end;
                     if parameterCount > 4 then
                        begin
                           ZeroToPas(paramPtr, paramPtr ^.params[ 5 ] ^, str);
                           topMargin := StrToNum(paramPtr, str);
                           if topMargin < 0 then
                              topMargin := marginDefault;
                           if parameterCount > 5 then
                              begin
                                 ZeroToPas(paramPtr, paramPtr ^.params[ 6 ] ^,
                                    str);
                                 bottomMargin := StrToNum(paramPtr, str);
                                 if bottomMargin < 0 then
                                    bottomMargin := marginDefault;
                              end; { if parameterCount > 5 }
                        end; { if parameterCount > 4 }
                  end; { if parameterCount > 3 }
            end; { if parameterCount > 2 }
         with viewRect do
            begin
               left := leftMargin;
               top := topMargin;
               right := leftMargin + fieldWidth;
               bottom := bottom - bottomMargin;
               if bottom < top then
                  bottom := top + 10
            end;
      end {GetMarginSettings};
   
   
   
   
   
   procedure GetFieldInfo;
      
      begin { GetFieldInfo}
         just := GetJustOfField(paramPtr, fieldName);
         theTextFont := GetFontOfField(paramPtr, fieldName);
         theTextStyle := GetTextStyleOfField(paramPtr, fieldName);
         theTextSize := GetTextSizeOfField(paramPtr, fieldName);
         theTextHeight := GetLineHeightOfField(paramPtr, fieldName);
      end {GetFieldInfo};
   
   
   
   
   
   procedure SetPPortInfo;
      
      begin { SetPPortInfo}
         TextFont(theTextFont);
         TextFace(theTextStyle);
         TextSize(theTextSize);
         myPrPort ^.gPort.txMode := srcOr;
      end {SetPPortInfo};
   
   
   
   
   
   procedure AdjustViewRect;
      
      begin
{ This will have to be modified if HyperCard ever uses the new Text Edit. }
         with viewRect do
            pageheight := bottom - top;
         numlines := pageheight div theTextHeight;
         if numlines < 1 then
            numlines := 1;
         pageheight := numlines * theTextHeight;
         with viewRect do
            bottom := top + pageheight;
         GetFontInfo(FontIRec);
         destRect := viewRect;
         destRect.bottom := 32767;
      end {AdjustViewRect};
   
   
   
   
   
   procedure GetPageCount;
{ This will have to be modified if HyperCard ever uses the new Text Edit. }
      
      begin { GetPageCount}
         with hTE ^^ do
            begin
               myPgCount := nLines div numlines;
               if (nLines mod numlines) <> 0 then
                  myPgCount := myPgCount + 1;
            end;
      end {GetPageCount};
   
   
   
   
   
   procedure SetTERec;
{ fill in the fields of the TextEdit Record }
      
      begin { SetTERec}
         MoveHHi(theText);
         HLock(theText);
         length := StringLength(paramPtr, theText ^);
         TESetText(theText ^, length, hTE);
         HPurge(theText);
         HUnlock(theText);
         DisposHandle(theText);
         TESetJust(just, hTE);
         with hTE ^^ do
            begin
               txFont := theTextFont;
               txFace := theTextStyle;
               txSize := theTextSize;
               fontAscent := theTextHeight - FontIRec.descent - FontIRec.leading;
               lineHeight := theTextHeight;
               crOnly := 1;
               inPort := grafPtr(myPrPort);
            end;
      end {SetTERec};
   
   
   
   
   
   procedure PrintLoop;
      
      var
               copies,
                   pg: INTEGER;
      
      begin { PrintLoop}
         if prRecHdl ^^.prJob.bJDocLoop = bSpoolLoop
         then
            numCopies := 1
         else
            numCopies := prRecHdl ^^.prJob.iCopies;
         for copies := 1 TO numCopies do
            begin
               for pg := 1 TO myPgCount do
                  begin
                     PrOpenPage(myPrPort, NIL);
                     myPrPort ^.gPort.grafProcs ^.rectProc := @ myStdRect;
{ It turned out that setting the bottlenecks any earlier didn't work -- }
{ PrOpenPage set them back to the postscript generating procedures. }
                     if PrError = noErr then
                        TEUpdate(viewRect, hTE);
                     PrClosePage(myPrPort);
                     OffsetRect(hTE ^^.destRect, 0, -pageHeight);
                  end; { for pg := 1 to myPgCount }
            end; { for copies := 1 to numCopies }
         PrCloseDoc(myPrPort);
         if (prRecHdl ^^.prJob.bJDocLoop = bSpoolLoop) and (PrError = noErr)
         then
            PrPicFile(prRecHdl, NIL, NIL, NIL, myStRec);
      end {PrintLoop};
   
   
   
   procedure MainLoop;
                              begin
                              PrintDefault(prRecHdl);
                              if PrError = noErr
                              then
                                 begin
                                    GetDialogCount;
                                    if dialogCount in [ 0, 1 ]
                                    then
                                       goAhead := TRUE
                                    else
                                       begin
                                          goAhead := PrStlDialog(prRecHdl);
                                          SendCardMessage(paramPtr, goToThisCard);
                                       end;
                                    if goAhead then
                                       begin
                                          if dialogCount = 0
                                          then
                                             goAhead := TRUE
                                          else
                                             begin
                                                goAhead := PrJobDialog(prRecHdl);
                                                SendCardMessage(paramPtr,
                                                   goToThisCard);
                                             end;
                                          if goAhead then
                                             begin
                                                ShowDialog;
                                                if PrValidate(prRecHdl) then
                                                   ; { we call PrValidate here only to give the printer }
{ driver a chance to grab our document name -- see TN #72 }
                                                myPrPort := PrOpenDoc(prRecHdl,
                                                   NIL, NIL);
                                                if PrError = noErr
                                                then
                                                   begin
                                                      SetDefaults;
                                                      GetMarginSettings;
                                                      GetFieldInfo;
                                                      SetPPortInfo;
                                                      AdjustViewRect;
                                                      hTE := TENew(destRect,
                                                         viewRect);
                                                      if hTE <> NIL
                                                      then
                                                         begin
                                                            SetTERec;
                                                            GetPageCount;
                                                            PrintLoop;
                                                            TEDispose(hTE);
                                                         end { if we could create new TEHandle }
                                                      else
                                                         begin
                                                            PrCloseDoc(myPrPort);
                                                            if MemError <> noErr
                                                            then
                                                               Fail(CONCAT(
                                                                  'Error ', NTS(
                                                                  MemError)));
                                                            if GetHandleSize(
                                                               theText) <> 0
                                                            then
                                                               begin
                                                                  HPurge(theText);
                                                                  HUnlock(
                                                                     theText);
                                                                  DisposHandle(
                                                                     theText);
                                                               end;
                                                         end;
                                                   end
                                                else
                                                   PrCloseDoc(myPrPort);
                                             end; { if user confirms job dialog }
                                       end; { if user confirms style dialog }
                                 end; { if PrintDefault worked OK }
                              DisposHandle(Handle(prRecHdl));
                           end; { if MemError = noErr when allocating print record }

   
   
   begin { procedure PrintField }
      InitCursor;
      goToThisCard := 'go to this card'; { for updating HyperCard's window }
      GetDialog;
      parameterCount := paramPtr ^.paramCount;
      if parameterCount > 0
      then
         begin
            ZeroToPas(paramPtr, paramPtr ^.params[ 1 ] ^, fieldName);
            err := GetField(paramPtr, fieldName, theText);
            if (theText <> NIL) and (err = noErr)
            then
               begin
                  HNoPurge(theText);
                  GetPort(currentPort);
                  PrOpen;
                  if PrError = noErr
                  then
                     begin
                        prRecHdl := THPrint(NewHandle(SIZEOF(TPrint)));
                        if (MemError = noErr) and (prRecHdl <> NIL)
                        then MainLoop;
                        PrClose;
                     end; { if PrError = noErr when opening print driver }
                  if PrError <> noErr
                  then
                     Fail(CONCAT('Error ', NTS(PrError)))
                  else
                     if MemError <> noErr then
                        Fail(CONCAT('Error ', NTS(MemError)));
                  SetPort(currentPort);
               end { if theText <> nil }
            else
               Fail(CONCAT('Error -- never heard of ', fieldName));
         end { if we have at least 1 parameter }
      else
         Fail('PrintField XCMD 1.4.1, 9 June 1988, 1988 Dartmouth College');
      if dlogOK then
         DisposDialog(myDlgPtr);
   end {PrintField}; { procedure PrintField }





procedure Main(paramPtr: XCmdPtr);
   
   begin { Main}
      PrintField(paramPtr);
   end {Main};





end.
