/*
 * configuration constants
 */

/*
 * If the connection closes or can't be open because of an error
 * retry this often
 */
#define RESTART_ON_ERROR_TIME (5*MINS)

/*
 * consider all errors transient and don't tell the user
 * till this much time has elapsed
 */
#define ERROR_ANNOUNCE_TIME (15*MINS)

/*
 * ask the server this often (default, server can set new minimum)
 */
#define POLL_TIME (5*MINS)

/*
 * Retransmit unaswered polls this often at first
 */
#define RETRANS_MIN_TIME (1*MINS)

/*
 * after this many fast RETRANS_MIN_TIME retransmits, go back to
 * using POLL_TIME.  Also queue up a timeout error to happen
 * in the usual ERROR_ANOUNCE_TIME seconds.
 */
#define NUM_FAST_RETRIES (4)

/*
 * Sleep this long when user wacks the snooze button
 */
#define SNOOZE_TIME (45*MINS)

#ifndef DEBUG
#define ABS_MIN_POLL (MINS*5)
#define ABS_MAX_POLL (60*MINS)
#else
#define ABS_MIN_POLL (30*SECS)
#define ABS_MAX_POLL (30*SECS)
#endif

/*
 * don't load sounds if it would leave less than this much space
 * in system heap
 */
#define SYS_RESERVE (16000)

#define MMW_port (902)

/*
 * server host numbers
 */
#define HNUM0 MK_HOST(128L,2L,15L,253L)
#define HNUM1 MK_HOST(128L,2L,11L,77L)

/*
 * server host if debugging
 */
#define deb_HNUM MK_HOST(128L,2L,35L,1L)
